/*
	Write & edit by Linjianghua(Xempo) 2004-2006, 2008-2011, 2012
	Free under LGPL
*/

#include "fspdir.h"

const char rootchs[]="/";

void (*pGetPdExt)(fsp_dir *dir);

// #ifdef  _STDIO_H
#define ZLMT  100
#define ZDIV  10
// #else

void setZero(fsp_dir *dir, int s)
{
if(isZero(dir->Format)){
	dir->zSize=s>0 ? s : (dir->selfnumbs<20 ? 3 : (dir->selfnumbs>1000 ? ZLMT :  dir->selfnumbs/ZDIV +1) );
	dir->zcache=(ZeroCache *)zalloc(  dir->zSize*sizeof(ZeroCache) );
	}
}

int getLenght(fsp_dir *dir)
{
int style=dir->Format;
return style&384 /*256|SimpleBase  data lib */ ? 
	FCU_NumPos : dir->DAUC * ( isType(style) ? sizeof(DAU)+1 : sizeof(DAU) )
	+ ( isZero(style) ? FCU_NumPos:FCU_NumPos+sizeof(int) );
}

fsp_dir *pdParent(fsp_dir *dir0, char *pth, char **fixname)
{
  if(pth){
    char *dn;
/*    for(dn=pth; *dn; dn++)
	if(*dn=='\\')*dn='/';*/
    dn=(char *)separChr(pth);
    if(dn==NULL)goto _jmp_;
    if(dn!=pth)*dn=0;
    else pth=(char *)rootchs;
    *fixname=dn+1;
    return pd_open(dir0, pth, DIR_READ);
  }
_jmp_: idxdscpt=0x7fff;
  *fixname=pth;
  if(dir0&&isNormDir(dir0))dir0->otherOpen++;
  return dir0;
}

int nameVerify(const char *dirnam)
{
static const char lmtstr[20]=
{ '\"', '*' , ';' , '\'', '?', ',', 9, 10, 13, 26, 32,':','=',
'[', ']', '<', '>', '#'   }; /* as # is datalib */
while(*dirnam=='.')dirnam++;
if(*dirnam==0||*dirnam=='-'||strchrs(dirnam,lmtstr)){ idxdscpt=InvName_13; return 0; }
return 1;
}

void setPdPara(fsp_dir *dir, const un_Int *pms)
{
    dir->Format=*pms&(Ch_Dir-1);
    dir->Num_FCUs_Block=pms[1];
    dir->Dir_FCUs_Block=pms[2];
    dir->DAUC=pms[3] ? (pms[3]>6000 ? 6000 : pms[3]) : 1;
    dir->mode=pms[4];
    dir->mdf|=NEW_DIR;
    dir->Num_FCU_Len=getLenght(dir);
}

fsp_dir *pdRead(fsp_lib *lib, DirFCU *du, dskadr_t adr)
{
    int j;
    fsp_dir *dir;
    for(j=0; j<lib->cnt_usedir; j++){
	dir=lib->usedirs[j];
	if(dir->own_adr==adr){
		dir->otherOpen++;
		return dir;
	}
    }
    if(adr<1)return (fsp_dir *)lib;
    dir=pdAlloc();
    idxdscpt = dkread(lib,adr, &dir->cur_numb_FCT,du? du->savelen:DIR_SAV_SIZ,1)<1 ? ErrScnFile_5:0x7fff;
    if(du)memcpy(&dir->tag,du,Dir_FCU_Len);
    else dkread(lib, dir->Own_FCU_Addr, &dir->tag,Dir_FCU_Len,1);
    dir->lib=lib;
    dir->Num_FCU_Len=getLenght(dir);
    return dir;
}

void pd_close(fsp_dir *dir, int mode)
{
if(dir && isNormDir(dir)){
  int i;
  fsp_lib *fsp;
//  if(pdTest(dir)==False)return;
  if(mode && dir->otherOpen ){
	--dir->otherOpen;
	return;
	}
  if(dir->mdf/*&63*/){
     fspTime(0, dir->datebuf);
     pdSave(dir);
  }
#ifndef FSP_SMALL
  if(dir->DataType)free(dir->DataType);
#endif
  fsp=dir->lib;
  if(isZero(dir->Format))free(dir->zcache);
  free(dir);
  for(i=0; i<fsp->cnt_usedir; i++)
      if(fsp->usedirs[i]==dir){
	while(i<fsp->cnt_usedir)fsp->usedirs[i++]=fsp->usedirs[i+1];
	fsp->cnt_usedir--;
	break;
	}
}
}

void addOpenList(fsp_dir *cdir)
{
if(isRoot(cdir))return;
fsp_lib *lib=cdir->lib;
if(lib->cnt_usedir>=lib->pre_usedir){
	lib->pre_usedir+=6;
	fsp_dir **usedirs=(fsp_dir **)malloc(sizeof(fsp_dir)*lib->pre_usedir);
	if(lib->cnt_usedir){
		int j;
		for(j=0; j<lib->cnt_usedir; j++)usedirs[j]=lib->usedirs[j];
		free(lib->usedirs);
	}
	lib->usedirs=usedirs;
}
setZero(cdir, 0);
lib->usedirs[lib->cnt_usedir++]=cdir;
}

fsp_dir *pd_open(fsp_dir *cdir, const char *path_nam, int _msg)
{
if(cdir){
 fsp_dir *_dir;
 DirFCU *dunit;
 int cn, i;
 char  *pthname, **dns;
 fsp_lib *lib=cdir->lib;
 dskadr_t  adr;
 idxdscpt=0x7fff;
 if(path_nam==NULL||*path_nam==0){
	if(isNormDir(cdir))cdir->otherOpen++;
	return cdir;
	}
 if(*path_nam=='\\' || *path_nam=='/')cdir=(fsp_dir *)lib;

 pthname=strdup(path_nam);	path_nam=pthname;
 cn=10000;
 dns=setargv(pthname, "/\\", &cn);
 _dir=cdir;
 for(i=0; i<cn; i++){
   pthname=dns[i];
   adr=cdir->parent_adr;
/*------------------ get special path ------------------*/
   if(*pthname=='.'&&pthname[1]=='.'){
         const char *pt=pthname+2;
         while( *pt=='.' )pt++;
         if(/* (pt!=pthname+2 &&*/ *pt==0 ){	/* otherwise whold like :  ...abc */
 p_dir:	if(adr<2)cdir=(fsp_dir *)lib;
	else {
		if(cdir!=_dir)pd_close(cdir, 2);
		cdir=pdRead(lib, NULL, adr);
	}
	switch((++pthname)[1]){
	case '.' : 	adr=cdir->parent_adr; 
		goto p_dir;
	case 0 : 	continue;
	}
         }
   }
   else if(*pthname=='.')
	switch( pthname[1] ){
	case '/': pthname++; /* self-own */
	case 0 : pthname++;
	}
/* --- make extend function ---- get special path end ----------------- */

   if(*pthname)
      if((dunit=pdSeek(cdir,pthname,_msg/* DIR_READ */))!=NULL){
	if(cdir!=_dir)pd_close(cdir, 2);
	cdir=pdRead(lib, dunit,dunit->pDir);
	}
      else {
	cdir=NULL;	   break;
	}
 } /* end for */
 free((void *)path_nam);
 free(dns);
 if(cdir){
	if(cdir->otherOpen==0)addOpenList(cdir);
	if(pGetPdExt/*&&pthname!=path_nam*/)pGetPdExt(cdir);
	}
 return cdir;
}
idxdscpt=NoBuff_2;
return NULL;
}

fsp_dir *pd_creat(fsp_dir *odir, char *pth, const un_Int *pms)
{
if(odir){
fsp_dir *cdir=NULL, *dir=NULL;
char *dirnam;
fsp_lib *lib=odir->lib;
if(pth==NULL||*pth==0)idxdscpt=PthInv_7;
else if( (cdir=pdParent(odir, pth, &dirnam) ) )nameVerify(dirnam);

if(idxdscpt>0x7ffd){
    if((cdir->mode&FSP_OEM)&&(cdir->mdf&NEW_DIR/* Create */)==0)idxdscpt=OEM_Dir_10;
    else {
    DirFCU *dirUnit=pdSeek(cdir,dirnam,DIR_WRITE);
    if(idxdscpt>0x7ffd){
	dir=pdAlloc();
	memcpy(dir->name,dirnam,DirNamLen-1);
	dir->lib=lib;
	setPdPara(dir,pms);
	dir->tag=1;
	dir->savelen=*pms & SimpleBase ? DIR_SAV_SIZ+OFFLEN : DIR_SAV_SIZ;

	cdir->selfdirs+=1; cdir->selfsize+=dir->savelen;
	lib->tolDir+=1; cdir->mdf|=1;
	if(isNormDir(cdir))dir->parent_adr=cdir->own_adr;
	if(lib->FCU_dyw==0)creatFCT(cdir,cdir->Dir_FCUs_Block*Dir_FCU_Len+sizeof(dskadr_t), 0);
	dir->own_adr=dirUnit->pDir ? dirUnit->pDir:lib->fsz;
	dir->Own_FCU_Addr=lib->FCU_dyw;
	lib->useSize+=dir->savelen;
	lib->fsz+=dir->savelen;
	addOpenList(dir);
	fspTime(0, dir->datebuf);
	free(dirUnit);
	if(cdir==odir&&cdir->mdf&FIRST_FCT)pdSave(cdir);
	setZero(dir, 0);
     } /* creat sucesse */
  }
}
else if(idxdscpt==NoDir_6)idxdscpt=PthInv_7;
// if( cdir!=odir )
pd_close(cdir,1);
return dir;
}
idxdscpt=NoBuff_2;
return NULL;
}
