/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2010, 2014, 2015
  Free under LGPL
*/

#include "jxswitch.h"
#include "options.h"
#include "numbtype.h"
#include "normal.h"
#include "stdfun.h"
#include "fspdir.h"
#include "dirext.h"
#include "fcu.h"
#include "infor.h"
#include "../objcom/comm.h"
#include "conspace.h"
#include "write.h"
#include "rebuild.h"

static fsp_dir *src_dir;
static fsp_lib *dstlib;
static int _over;
static BOOL vbs;

int copyCnt;

BOOL getSpace(char *extparm,int *s,int *d)
{
if(extparm==NULL||*extparm==0)return False;
int i, val=-1, len=extParaLen(extparm);
*s=-1; *d=-1;
for(i=0;i<len;i++)
  if(extparm[i]=='.'||i==0){
	if(extparm[i]=='.')i++;
	if(extparm[i]>47&&extparm[i]<58){
	    val=atoi(extparm+i);
	    if(*s>-1)*d=val;
	    else *s=val;
	}
	}
 return *s>-1||*d>-1 ? True : False;
}

/*BYTE *FormatStat(fsp_dir *s_dir, BYTE *srcStat)
{
//return fmtStat;
}*/

int selSpace(int sel)
{
fsp_lib *lib1=NULL;
  if(sel>LASTSPACE||sel<0)goto nullspace;
//  if(sel>0){
	lib1=workspace[sel];
	if(lib1==NULL||lib1->fpt==NULL){ 
		nullspace: fspHB(48,1); 
		return -1;
		}
//	}
//  else if(sel==0){ fspHB(50,1); return -1; }
return sel;
}

BOOL SetMultSpac(fsp_lib **s_lib, fsp_lib **d_lib, char *extparm)
{
int s,d;
if(getSpace(extparm,&s,&d)){
  if((s=selSpace(s))>0)*s_lib=workspace[s];
  else return False;
  if((d=selSpace(d))>0)*d_lib=workspace[d];
  else return False;
}
return True;
}

int baseCopy(fsp_dir *s_dir,fsp_dir *d_dir,int srcnmb,int dstnmb,BYTE *srcStat)
{
char *spt, *dpt;
MAU *Sends;
BYTE *stat=seekFCU(d_dir,dstnmb,NULL,NUMB_READ);
int n=s_dir->DAUC, rt=0;
dskadr_t adr=-1;/* none type dau address is 0, so let it -1 */
if(stat){/*  specied data of dstnmb denied  */
	if((d_dir->Format&FSP_OEM) && (stat[1]&FSP_OEM) ){
		fspHB(45,1); free(stat); return 0;
		}
	adr=*(dskadr_t *)(stat+FCU_DAUPos(d_dir,0)); free(stat);
}
Sends=MAUalloc(n);
if(srcStat){ stat=srcStat; readFCU(s_dir,srcStat,Sends,n); }
else stat=num_read(s_dir,srcnmb,Sends,n);

if(stat){
     if( adr==*(dskadr_t *)(stat+FCU_DAUPos(s_dir,0)) )DefaultManu(SelfCpy_18);
     else {
	//=FormatStat(s_dir,stat/* src */ );/* stat is static-val, every call will change */
	BYTE *fmtStat=(BYTE *)malloc( s_dir->Num_FCU_Len );
	memcpy(fmtStat, stat, FCU_NumPos);
	if(isType(s_dir->Format))
		memcpy(fmtStat+FCU_NumPos, stat+FCU_TypePos(s_dir->Format), s_dir->DAUC );
	else memset(fmtStat+FCU_NumPos, _void, s_dir->DAUC );
	fmtFCU fmt={ fmtStat, dstnmb, 8, 0 };
	if((rt=writeNFCU(d_dir, &fmt, Sends,n))!=0 && vbs ){
	    spt=pdPathNam(s_dir, src_dir, 0);
	    dpt=pdPathNam(d_dir,dst_dir,0);
	    char buf[1024];
	    sprintf(buf, "%s/%d ==> %s/%d", spt, srcnmb, dpt, dstnmb);
	    free(spt);	free(dpt);
	    msgShow(buf);
	}
	free(fmt.format);
       }
 if(stat!=srcStat)free(stat);
 freeMAU(Sends,n);
 }
else reportBug();
free(Sends);
return rt;
}

int _copyNumbs(fsp_dir *sdir,BYTE *dsb)
{
  fsp_dir *ddir=dst_dir;
  if(sdir!=ddir || sdir->own_adr!=ddir->own_adr){
      BYTE *unit=dsb;
      int i, numb;
      BOOL zero;
     if(sdir->own_adr!=src_dir->own_adr){
	char *dirnam=pdPathNam(sdir, src_dir, 1);
	ddir=DirOpen(dst_dir,dirnam);
	free(dirnam);
	if(idxdscpt<0x7ffd){ reportBug(); ddir=dst_dir; idxdscpt=0x7fff; }
	}
     zero=isZero(sdir->Format);
     for(i=0; _over!=Esc&&i<sdir->Num_FCUs_Block; i++,unit+=sdir->Num_FCU_Len){
	if(zero)numb=sdir->NumbForZero ++;
	if(*unit==1 ){
		if(!zero)numb= *(int *)(unit+FCU_NumPos);
		if(baseCopy(sdir,ddir,numb,numb,unit))/* copy can change dir->NumbForZero */
	  		copyCnt++;
 /* because don't break copys, so ignore err, don't OPM like rebuild */
	}
	}
    if(ddir!=dst_dir)pd_close(ddir, 1);
/* every workspace->CurDir must exist, CurLib only is one of workspace */
  }
  return (_over!=Esc ? 1:0);
}

int _copyDirs(fsp_dir *pcdir,fsp_dir *sdir)
{
char *dirnam;
un_Int lst[pd_param_cnt];
if(_over==Esc ||
 (pcdir->lib==dstlib && sdir->own_adr==dst_dir->own_adr))/* defence self-copy loop */
	return 0;
dirnam=pdPathNam(sdir,src_dir,1);
getPdPara(sdir, lst);
pcdir=pd_creat(dst_dir, dirnam/*src_dir? dirnam:dirnam+1*/,lst);
free(dirnam);
// if(pcdir){ this error ought to no happen, as pdCopy(...) have limit
	pd_close(pcdir, 1);
//	return 1;
// }
return 1;
}

/*   pdCopy & NumbCopy follow :  */
// const char *plst[2]={ "--reply", "--verbose" };/* ==> 1024<<0, 1024<<1, 1024<<2... */
void pdCopy(fsp_lib *curlib, int n,char **pm,char *extparm, int nCom)
{
  fsp_lib *s_lib=curlib, *d_lib=curlib;
  fsp_dir *ddst, *sdir;
  int msg, i;
  if(SetMultSpac(&s_lib, &d_lib, extparm)==False)return;
  if(d_lib==NULL||s_lib==NULL){ fspHB(NoBuff_2,1); return; }
static const char *cploop[6]={"-n", "-d", "-i", "-t", "-r", "-v" },
	*_cploop[6]={"--num", "--dir", "--include", "--total", "--reply", "--verbose"};
int brwVal[6];
memset(brwVal, 0, sizeof(int)*6);
ProcOpt optBrows={
	6,
	cploop, _cploop,
	brwVal,
	0,
	NULL
	};
arglists *alst=procParas(n, pm, &optBrows, NULL);
switch(alst->argc){
case 0 : 
case 1 : fspHB(60+alst->argc, 1);
	showUsage(nCom);
	argsFree(alst);
	return;
// case 2 : break;
default : unPara(alst, 3);
}
msg=0;  _over=0;  vbs=0;
for(i=0; i<6; i++)
    if(brwVal[i])
	switch(i){
	case 3 : msg=7;
		break;
	case 4 : _over='a';
		break;
	case 5 : vbs=True;
		break;
	default : msg|=1<<i;
	}

  sdir=pd_open(s_lib->CurDir, alst->argv[0], DIR_BROW);
  argsFree(alst);
  if(idxdscpt>0x7ffd){
    un_Int lst[5];
    getPdPara(sdir, lst);
    ddst=DirOpen(d_lib->CurDir,pm[1]);
    if(idxdscpt>0x7ffd){
	if(/* ddst&& */d_lib==s_lib&&ddst->own_adr==sdir->own_adr){
		DefaultManu(SelfCpy_18); return;
		}
	char *ptr;
	fsp_dir *_dir;
	if(pm[0][0]=='.'&&pm[0][1]==0)pm[0]=s_lib->CurDir->name;
	if( (ptr=(char *)separChr(*pm)) )ptr++;
	else ptr=*pm;
	_dir=pd_creat(ddst, ptr, lst);
	if(idxdscpt<0x7ffd){
		char buf[1024];
		sprintf(buf, "%s/%s", pm[1], ptr);
		PrnTxt(0, 31, buf);
		goto _err_msg_;
		}
	pd_close(ddst,1);
	ddst=_dir;
    }
    else ddst=pd_creat(d_lib->CurDir,pm[1],lst);

    if(idxdscpt<0x7ffd){
	printf(pm[1]); /* here can't ignore */
	goto _err_msg_;
	}
    else {
	src_dir=sdir;  dst_dir=ddst; /* dir->NumbForZero=0;*/
	dstlib=d_lib; /*CurLib=curlib; above 3 var is extern */
	copyCnt=0;	
	if(nCom==FSP_dircps)msg|=7;
	else if((msg&3)==0)msg=1;
// simplebase cp to fsp; simplebase cp to simplebase
	DirFullBrow(sdir,msg,_copyNumbs,_copyDirs);
//	if(PDbrow(...)==0)reportBug(); above have limit, so here no thus
	if(getMsg){
		char buf[128];
		sprintf(buf, "  Total copy %d\n", copyCnt);
		msgShow(buf);
		}
	else printf("  Total copy \033[7m %d \033[0m\n",copyCnt);
	pd_close(ddst,1);
    }
    pd_close(sdir, 2);
  }
  else {
	_err_msg_: reportBug();
	showUsage(nCom);
	}
}

void NumbCopy(fsp_lib *curlib,char **pm,char *extparm)
{
  int srcnmb, dstnmb, msgNo;
  fsp_lib *s_lib=curlib, *d_lib=curlib;
  fsp_dir *d_dir, *s_dir;
  char *dstpth, *srcpth=divPath(*pm,&srcnmb);
  if(numNone){
	char buf[800];
	sprintf(buf, " Source: %s  ", *pm);
	PrnTxt(0,31,buf);
	fspHB(WrongOpera_22, NoQust);	showUsage(FSP_cp);
	return;
	}
  if(SetMultSpac(&s_lib,&d_lib,extparm)==False)return;
  if( d_lib==NULL || s_lib==NULL){ fspHB(NoBuff_2,1); return; }
  s_dir=DirOpen(s_lib->CurDir,srcpth);
  msgNo=idxdscpt;
  if(msgNo>0x7ffd){
    dstnmb=srcnmb; _over=0;
    dstpth=divPath(pm[1],&dstnmb);
    d_dir=DirOpen(d_lib->CurDir,dstpth);
    msgNo=idxdscpt;
    if(msgNo>0x7ffd){
// simplebase cp to fsp; simplebase cp to simplebase	
/*	copyCnt=0; why old=-1 ? */
	baseCopy(s_dir,d_dir,srcnmb,dstnmb,NULL);
/*	free(Sends);*/
	pd_close(d_dir,1);
    }
    else msgShow(pm[1]);
    if(isNormDir(s_dir)&&s_dir!=s_lib->CurDir)free(s_dir);
  }
  else printf(*pm);
  if(msgNo<0x7ffd){
	DefaultManu(/*PthInv_7*/msgNo);
	showUsage(FSP_cp);
	}
}

