/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2010, 2014
  Free under LGPL
 */

#include "jxswitch.h"
#include "stdfun.h"
#include "fspdir.h"
#include "read.h"
#include "write.h"
#include "script.h"
#include "conspace.h"
#include "infor.h"
#include "dlist.h"
#include "dialogid.h"
#include "../objcom/comm.h"

extern const char SPC[]; // in dirloop

int bakdscpt=0x7fff, lock;

#include "input.c"

char Conf_val[8];
const char *libfmt, runLog[]="//Log";
const _Int *kval;
BOOL errSig_space;

void RunLog(const char *chs)
{
if(*workspace&&(workspace[0]->openMode&OpenAlway)){
	MAU mau;
	mau.buf=(char *)chs; mau.len=0; mau.alen=0;
	numInsLmt((fsp_dir *)workspace[0], runLog, &mau, 0/* append mode */, 80);
	}
}

int indexUsage(int nCom, const _Int *coms)
{  
int i;
for(i=0; coms[i]; i++)if(nCom==coms[i])return i;
return -1;
}

char *getInfor(int idx,BOOL root)
{
if(*workspace&&(workspace[0]->openMode&OpenAlway)){
  MAU send;
  BYTE *stat;
  bakdscpt=idxdscpt;
  fsp_dir *dir=root? (fsp_dir *)workspace[0] : pd_open((fsp_dir *)*workspace, "Usage", DIR_READ);
  if((stat=num_read(dir, idx, &send,1)))free(stat);
  if(root==False){
	pd_close(dir, 1);
	errSig_space=True; /* for mult workspace show */
	}
  return send.buf;
}
return NULL;
}

void showUsage(int nCom)
{
char *pt=GetUsage(indexUsage(nCom, kval));
if(pt){
	msgShow(pt);	free(pt);
	}
}

void scriptTips(int msg)
{
if(diguei && isRS){
   sprintf(OutBuf,"  >> %s %d: ",scpfname,scpline);
   if(getMsg){
	sprintf(OutBuf, msg>1 ? "%s %d\n" : "%s %d",scpfname,scpline);
	PrnTxt(0,33, OutBuf);
	if(msg>1){
		switch(popMsg(scpbuf, NULL, ScriptErrorId, fspX)){
		case 1 :  CommNumb=Quit_Script_Run; /* quit this script */
		break;
		case 0 :  CommNumb=End_Script_Run; /* abort  all script */
		}
	}
	else getMsg(scpbuf);
	}
   else {
	char tmp[8];
	printf("\033[33;1m%s \033[0;7m%d\033[0m : ",scpfname,scpline);
	printf(msg>1 ? "%s\r\n%s\r\n":"%s\r\n",scpbuf, msg>1 ?quitScp:SPC);
	if(msg>1)switch(inCon(tmp,4)){
		case 'q' : CommNumb=FSP_quit; /* quit all script */
			break;
		case 'e' :  CommNumb=End_Script_Run; /* abort this script */
		}
	}
   strcat(OutBuf, scpbuf);
   RunLog(OutBuf);
	}
}

const char *pErrParam;
void ErrInfo(int idx, const char *pm)
{
PrnTxt(1, 32,pm); 
pErrParam=pm;
fspHB(idx,4);
}

int fspHB(int idx,int msg)
{ // msg 2|1 : no WarnStyle | no quest
char  *pt;
idxdscpt=idx; /* as msg */
pt=GetManu(idx);
if(msg&NoWarn){
	if(pt){
		int x=popMsg(pt, NULL, msg&NoQust ? -3 : 0, fspX);
		free(pt);
		return x;
	}
	return -1;
}

if(msg)PrnTxt(2, 31,"**");
if(pt){
	sprintf(OutBuf,"  %s%c", pt, ErrParam);
	msgShow(OutBuf);
	if(Conf_val[1]){
		sprintf(OutBuf,"  %s  ** %s%c", msg&showParam? pErrParam:SPC, pt, ErrParam);
		RunLog(OutBuf);
		}
	free(pt);	ErrParam=32;
}
else {
	char buf[64];
	sprintf(buf, "  No about message: %d",idx);
	msgShow(buf);
}
/* if(rtlout!=stdout)fprintf(rtlout,"\n\n"); */
scriptTips(2);
return 0;
}

void DefaultManu(int idx)
{
fspHB(idxdscpt<0x7ff0? idxdscpt:idx,1);
}
//#define reportBug() DefaultManu(28)

void fspInfo(fsp_dir *cdir, char *buf)
{
if(cdir){
  fsp_lib *lib=cdir->lib;
  char verbuf[16];  sprintf(verbuf, "Ver%d.%d.%d", lib->ver1, lib->ver2, lib->ver3);
  sprintf(buf, libfmt, lib->fname ? rstrrchr((char *)lib->fname, ROOT_CH,ROOT_CH) : verbuf,
	lib->tolNumb,lib->tolDir,lib->useSize,lib->fsz);
/*  buff=pdPathNam(lib,cdir,NULL,1); this useful in script run */
}
else {
   char *dat=GetManu(2);
   if(dat){ scopy(buf,dat); free(dat); }
 }
}

int putmsg(const char *txt, const char *cap, int fg, void *p)
{
static const int keys[7]={ Esc, 'n', 'y', 'e', 's', 'q', 0 };
int code=1;
if(cap)msgShow(cap);
if(txt)printf(txt);
  while(fg>-1 && isdone(code,keys)==False){
	char bu[8];
	code=inCon( bu,7);
	}
return code;
}

