/*
	林江华编写，2009年7月
	Free under LGPL
*/

#ifndef		_FAST_LIST_
#define		_FAST_LIST_

//----------- version 1.3 ------------
#include <stdlib.h>
#include "_fastblock.h"
#include "mau.h"
#include "envpath.h"

extern int namcmp(const char *nam1, const char *nam2, bool cs);

class QStrList;

class FastBlock : protected _FastBlock {
public :
FastBlock(int m=0, int limit=0x7fffff00);
FastBlock(char *dat, const char *div=0, int m=0, int lmt=0x7fffff00);
FastBlock(char **lst); // such as: if(argc>1)OpenDoc(FastBlock(argv+1), 0, 0);
FastBlock(FastBlock & chslst);
// ~FastBlock();

inline int index() const
{
return __idx;
}

inline void setIndex(int idx)
{
__idx=idx;
}

inline char *selchs()
{
return list[__idx];
}

virtual int add(const char *txt, const char *div=0);  // return add pos

int memDiv(const char *dv_chr)/* dv_chr指分隔符, 内部调用时一般为0（无效） */
{
return _memDiv(dv_chr);
}

void rem(int idx) // buf no change, list[...] order change
{
return _rem(idx);
}

void resetMem(char *dat, const char *div_chr=NULL)
{
return _resetMem(dat, div_chr);
}

void insert(const char *txt, int idx);

// in fact, it's remove(int);
// buf[] have a lot no used space, like fmtinp(list[i]...), that must use remove(i), no use rem(i)
void remove(int idx); // buf change, but list[...] order as org

void sort( bool a, bool cs );  // a=true 升序

void copy(FastBlock & lst);

int find(const char *dat);

void beAppend(FastBlock &lst){
	for(int i=0; i<cnt; i++)lst.add(list[i]);
}

QStrList cvtQStrList();

// inline void _rem(int idx){ cnt--; for(int i=idx; i<cnt; i++)list[i]=list[i+1]; }

int count() const
{ return cnt; }

unsigned int length() const
{ return len; }

char *lstIndex(int idx) const
{ return list[idx]; }

char **plist() const
{ return list; }

// free: buf & list ==> ReSetMem(NULL); 
char *buffer() const
{ return buf; }

int limit() const
{ return lmt; }

void setLimit(int lt=0x7fffff00){ lmt=lt; }

void setMode(int s){ mode=s; }

void setPlist(char **plst){ for(int i=0; i<cnt; i++)list[i]=plst[i]; }

void setMau(MAU *mau){ mau->buf=buf;	mau->len=len-1; }

void getFromMau(MAU *mau){ buf=mau->buf;	len=mau->len+1;	}

char *bufferString(char div) const
{
for(unsigned int i=0; i < len-1; i++)
	if(buf[i]==0)buf[i]=div;
return buf;
}

int del(const char *pt)
{
int idx=find(pt);
if(idx>-1)_rem(idx);
return idx;
}

int erase(const char *pt)
{
int idx=find(pt);
if(idx>-1)remove(idx);
return idx;
}

void setStrList(StrList *rc){ rc->argc=cnt; rc->argv=list; }

private :
int __idx;
bool sortTag; // resort must use after rem(i).
};

#endif

