/*
	Write by LinJiangHua (xempo) 2010-2015
	Free under LGPL
*/

#include <fcntl.h>
#include <qcursor.h>
#include <qmessagebox.h>
#include <qtoolbutton.h>

#include "fspdir.h"
#include "dirloop.h"
#include "dirext.h"
#include "shellcom.h"
#include "write.h"
#include "fcu.h"
#include "infor.h"
#include "conspace.h"
#include "extfunc.h"
#include "export.h"

#include "../libnorm/browslist.h"
#include "filesan.h"
#include "xfunc.h"
#include "helpwdg.h"
#include "genset.h"
#include "fileatt.h"
#include "personlog.h"
#include "stocks.h"
#include "genlife.h"
#include "simpleimage.h"
#include "inputdlg.h"
#include "searchmodify.h"

#include "../rtdata/en/target/filesor.h"
#include "fspcon.h"
#include "../fsplus/objcom/comm.h"
#include "chMT.h"

#define statusBarError(cap, dst)  ErrorQuestion(this, normError, dst, cap )

extern int stocksFunc(fsp_dir *pdir, fsp_dir *dir);
extern int lifeFunc(fsp_dir *pdir, fsp_dir *dir);

int sysCmdId=-1;

BrowsList brwList, curItemList;

QMetaObject *Filesan::metaObj = 0;
static QMetaObjectCleanUp cleanUp_Filesan( pluzone, &Filesan::staticMetaObject );

const QUParameter params[3] =  { {NULL, &static_QUType_int, 0, QUParameter::In},
		{NULL, &static_QUType_ptr, 0, QUParameter::In},
		{NULL, &static_QUType_ptr, 0, QUParameter::In},
 } ;
const QUMethod slot_3_3={NULL,3, params};
const QUMethod slot_int={NULL, 1, params};
const QUMethod slot_ptr={NULL,1, params+1};
const QUMethod slot_0_0={ NULL, 0, NULL };

QMetaObject* Filesan::staticMetaObject()
{
  if ( !metaObj ){
    static const QMetaData slot_tbl[] = {
	{ "showfn(int)" , &slot_int, QMetaData::Private },
	{ "showHide()", &slot_0_0, QMetaData::Private },
	{ "attrib()" , &slot_0_0, QMetaData::Private },
	{ "iCurCh(QIconViewItem*)", &slot_ptr,  QMetaData::Private },
	{ "about(int)" , &slot_int, QMetaData::Private },
	{ "asSrc()" , &slot_0_0, QMetaData::Private },
	{ "selall()" , &slot_0_0, QMetaData::Private },
	{ "del()" , &slot_0_0, QMetaData::Private },
	{ "toggRen()" , &slot_0_0, QMetaData::Private },
	{ "clearTag()" , &slot_0_0, QMetaData::Private },
	{ "dirDoRen()" , &slot_ptr, QMetaData::Private },

	{ "clearPElst()" , &slot_0_0, QMetaData::Private }, //11
	{ "deleteTag()" , &slot_0_0, QMetaData::Private },
	{ "proEdit2()", &slot_0_0, QMetaData::Private }, 
	{ "refresh()" , &slot_0_0, QMetaData::Private },  // 14

	{ "beginDir()" , &slot_0_0, QMetaData::Private },
	{ "genSet()", &slot_0_0, QMetaData::Private}, // 16
	{ "Sort(int)", &slot_int, QMetaData::Private},
	{ "seltag(int)", &slot_int, QMetaData::Private},//18
	{ "chList()", &slot_0_0, QMetaData::Private },
	{ "menuBrows(int)" , &slot_int, QMetaData::Private },
	{ "Back()", &slot_0_0, QMetaData::Private },
	{ "Next()", &slot_0_0, QMetaData::Private },
	{ "tagList()", &slot_0_0, QMetaData::Private },
	{ "addTag()", &slot_0_0, QMetaData::Private },//24
	{ "delTag()" , &slot_0_0, QMetaData::Private },
	{ "RemTag(int)", &slot_int, QMetaData::Private },
	{"cp2dir()", &slot_0_0, QMetaData::Private }, // 27 -29 don't change
	{ "proEdit()", &slot_0_0, QMetaData::Private },
	{"mv2dir()", &slot_0_0, QMetaData::Private }, // 27 -29 don't change
	{ "chPathComb()" , &slot_0_0, QMetaData::Private },
	{ "doRen()" , &slot_ptr, QMetaData::Private }, //31
	{ "fcopy()" , &slot_0_0, QMetaData::Private }, // FCOPY
	{ "creatSymlnk()", &slot_0_0, QMetaData::Private }, 
	{ "move()" , &slot_0_0, QMetaData::Private }, 
	{ "fdup()", &slot_0_0, QMetaData::Private }, // FDUP
	{ "chSel()" , &slot_0_0, QMetaData::Private }, //36
	{ "selIco()" , &slot_0_0, QMetaData::Private }, // 37
	{ "mousClk()", &slot_3_3, QMetaData::Private }, // 38
	{ "dbclick()", &slot_ptr, QMetaData::Private }, 
	{ "enter()", &slot_ptr, QMetaData::Private }, // 40
	{ "open()" , &slot_0_0, QMetaData::Private },
	{ "opens(int)" , &slot_int, QMetaData::Private }, //42
	{ "new()", &slot_0_0, QMetaData::Private },
	{ "runPluzone()" , &slot_0_0, QMetaData::Private },
	{ "imageBrow()" , &slot_0_0, QMetaData::Private }, 
	{ "renCase0()" , &slot_0_0, QMetaData::Private }, // 46 don't change this
	{ "renCase1()" , &slot_0_0, QMetaData::Private }, // 47 don't change this
	{ "toolPanelLeft()",&slot_0_0, QMetaData::Private },
	{ "parentDir()" , &slot_0_0, QMetaData::Private },
	{ "lifeShow()" , &slot_0_0, QMetaData::Private },
	{ "sImage()" , &slot_0_0, QMetaData::Private },
	{ "case()", &slot_0_0, QMetaData::Private },
	{ "menuOpen(int)", &slot_int,  QMetaData::Private },
	{ "asDC()", &slot_0_0,QMetaData::Private },
	{ "cpLog()" , &slot_0_0, QMetaData::Private },
	{ "FspCon()" , &slot_0_0, QMetaData::Private },
	{ "lang(int)" , &slot_int, QMetaData::Private },
	{ "multPR()" , &slot_0_0, QMetaData::Private },
	{"addSrc()", &slot_0_0, QMetaData::Private },  // 59
	{ "delStock(int)" , &slot_int, QMetaData::Private },

	{ "clearBrwlst()" , &slot_0_0, QMetaData::Private }, //61
	{ "tagSort(int)" , &slot_int, QMetaData::Private },
	{ "multPanel()" , &slot_0_0, QMetaData::Private }, //63
	{ "Qt3()",  &slot_0_0, QMetaData::Private },
	{ "popSM()" , &slot_0_0, QMetaData::Private }, // 65
	{ "codec(int)" , &slot_int, QMetaData::Private }, // 66
	{ "fspZone()" , &slot_0_0, QMetaData::Private },
	{ "plog()" , &slot_0_0, QMetaData::Private },
	{ "stocks(int)" , &slot_int, QMetaData::Private },
	{ "life(int)" , &slot_int, QMetaData::Private },
	{ "stocksShow()" , &slot_0_0, QMetaData::Private },
	{ "onlyfile()", &slot_0_0, QMetaData::Private },
	{ "newZDir()" , &slot_0_0, QMetaData::Private }, // 73
	{ "fspexe()" , &slot_0_0, QMetaData::Private },
	{ "import()" , &slot_0_0, QMetaData::Private },
	{ "openFsp(int)" , &slot_int, QMetaData::Private }, // 76
	{ "clearFsp()",  &slot_0_0, QMetaData::Private },
	{ "lCurCh(QListViewItem*)", &slot_ptr,  QMetaData::Private },
	{ "doNotify()" , &slot_0_0, QMetaData::Private },
	{"chmod()", &slot_0_0, QMetaData::Private },
	{"chtim()", &slot_0_0, QMetaData::Private },
	{"freshIV()", &slot_0_0, QMetaData::Private },
	{ "newDir()", &slot_0_0, QMetaData::Private },
	{ "restart()", &slot_0_0, QMetaData::Private },
	{ "shutdown()", &slot_0_0, QMetaData::Private },
	{ "iconviewDrop(QDropEvent*)",&slot_ptr, QMetaData::Private }, // iconView drop
	{ "dcmpr()", &slot_0_0, QMetaData::Private },
	{ "dccmp()", &slot_0_0, QMetaData::Private }, // 88
	{ "cmpr()", &slot_0_0, QMetaData::Private },
	{ "cmprs(int)", &slot_int, QMetaData::Private },
	{ "ccmp()", &slot_0_0, QMetaData::Private },
	{ "ccmps(int)", &slot_int, QMetaData::Private },
	{ "fspAr()", &slot_0_0, QMetaData::Private },
	{ "fspAr(int)", &slot_int, QMetaData::Private },
	{ "fspCAr()", &slot_0_0, QMetaData::Private },
	{ "fspCAr(int)", &slot_int, QMetaData::Private },
	{ "dirsum()", &slot_0_0, QMetaData::Private }
    };
    metaObj = QMetaObject::new_metaobject(pluzone, QMainWindow::staticMetaObject(), slot_tbl, 98,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_Filesan.setMetaObject( metaObj );
    }
  return metaObj;
}

#ifndef QT_NO_PROPERTIES
bool Filesan::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

void Filesan::clearView()
{
if(_filelist)_filelist->clear();
else _iconview->clear();
}

void Filesan::seekPath(const char *pth)
{
fsKillTimer();
if(isDirList(pth))treeview->seekDir(pth, SHOW_LIST/* first show MainView, not use SHOW_TREE_LIST*/, NULL);
else {
	char *dn=strdup(pth);
	mainViewCWD(dn, false);
	free(dn);
}
// PreCopyStats();
fsStartTimer();
}

void Filesan::freshDirItem(LVItem *tv_it)
{
switch(modul){
case  _FASTTAGS : 
case  _PLACE :
case  _OSROOT : 
   if(tv_it){
	char *pth=modul==_FASTTAGS ? treeview->tagFullPath(tv_it) : treeFullPath(tv_it);
	if(pth==NULL)return;
	if(strstr(pth, "/.")==NULL){ // isHideDir
		if(tv_it->isSelected()){
		    if(setCWD(pth, FRESH_VIEW, tv_it)==0)
			treeview->ensureItemVisible(tv_it);
		}
		else setCWD(pth, FRESH_SUB_TREE, tv_it);
	}
	else if(tv_it->isSelected())setCWD(dirNam, SHOW_LIST);
	free(pth);
     }
  break;
default : updatePluzone(false); //setCWD(dirNam, SHOW_LIST);
}
}

inline void ProEdit::showMessage(const char *buf, int color)
{
sbar->showMsg(buf, 99, 1, color);
}

int Filesan::doProEdit(const char *pfnam, bool mult, int pos, const char *fun)
{
const char *fn, *fnam=accepath( pfnam, R_OK, &pathList);
if(fnam==NULL){
_err_:	char buf[strlen(pfnam)+120];
	QWidget *wdg;
	QApplication::beep();
	sprintf(buf, notOpen, pfnam);
	wdg=qApp->activeWindow();
	if(wdg!=this)((ProEdit *)wdg)->showMessage(buf, 0x98201b);
	else sbar->showMsg(buf, 80, 1, 0x98201b);
	return 0;
}
else {
   int i, t=0;
   ProEdit *edt;
   struct stat64 st;
   if(*fnam!='/'){
	const char *pt=catstr(pathList.argv[pathList.argc-1], fnam,'/');
	free((void *)fnam);
	fnam=pt;
	}
   stat64(fnam, &st);
   if(S_ISDIR(st.st_mode)){ //  proedit F6 can toggle this
	free((void *)fnam);
	goto _err_;
	}
   for(i=0; (edt=proEditList.at(i)); i++){
	fn=edt->getFileName();
	if(fn && strcmp(fn, fnam)==0){
		if(t<edt->getNumb()+1)t=edt->getNumb()+1;
		if(mult==false)break;
		}
  }
  if(t==0||mult){
	edt=new ProEdit(this, fnam, t);
	switch( (i=edt->exec(pos, fun)) ){
	case 0 : // fnam have free
		statusBarError("Open fail", pfnam);
		break;
	case -1 : infoWidget(pfnam, NULL, tooLargeId, this);
	}
	return i;
	}
  else { 
	showTop(edt);
	if(pos>0){
		edt->editor()->setCursorPosition(pos,0);
		edt->editor()->find(fun,true,false);
	}
	edt->showMessage(hasLoaded, 0);
   }
 }
return 1;
}

void Filesan::execProg(int sw, FastBlock *sel, int idx)
{
char *fn=sel->selchs();
if(fn){
int i=0, t=0, Idx, cn, Id;
char *chs;
struct stat64 st;
fn=strdup(fn);
switch( Idx=isExist(fn, &st) ){
case lost_Link : showLink(sbar, lnkNone, fn, 0xe03a0a );
	break;
case symLink : stat64(fn, &st);
default :	if( S_ISDIR(st.st_mode) ){
		if(sw==exeOpens){
			if(strcmp(pluzone,opens.lstIndex(idx)))goto _jmp_;
			else runFilesan(/*opens.lstIndex(idx)*/ fn);
			break;
		}
		seekPath(fn);
	}
	else {
_jmp_:		if(sel->plist()==NULL)sel->memDiv(NULL);
		if(sw==exeOpens){
			chs=opens.lstIndex(idx);
			cn=sel->count();
			char	*lst[cn+2];
			while( ++i <=cn )
				lst[ i ]=sel->lstIndex(i-1);
			lst[0]=chs;	lst[i]=NULL;
			if(fastBrows(this, chs, (const char **)lst+1))break;
			if(fork()==0){
				execvp(chs, lst); // 成功无返囄17
				char buf[2000];
				sprintf(buf, failToExe, chs, lst[1]);
				sbar->showMsg(buf, 99, 0x982020);
				ManuTxt(-1, buf);
				_exit(1);
			}
			break;
		}
		else if( FileAssoc ){
		    MAU mau[2];
		    bool rt=false;
		    int cnt=FileAssoc->selfnumbs-1;
		    Id=1;
		    while( rt==false&&i<cnt&&Id<0xffff/* safe */ ){
		    _filesor_loop:	FastBlock proglst; //(NoFree);
			if(numbRead(FileAssoc, Id++, mau, 2, false)>-1){	i++;
			proglst.getFromMau(mau);
			if( sw==-38
				|| (rt=namefilters(fn, mau[1].buf, 3)) ){
					ExecProg(this, &proglst, sel);
					cnt=-1; // end
					}
			free(mau[1].buf);
			}
			}
		    if(rt==false &&cnt>0){
			if(isExecable(u_id, g_id, &st)){
				static const char ELF_Info[4]={ 0x7f, 'E', 'L' , 'F',  };
				static const char exeScpt[3][10]={"/bin/sh", "/bin/bash", "/bin/ash" };
				char buff[128], *ptr;
				FILE *fp=fopen(fn,"rb");
				fread(buff, 128,1, fp);
				fclose(fp);
				while(t<4 && buff[t]==ELF_Info[t])t++;
			 	if(t<4 || buff[4]<(sizeof(long)>4 ? 2 : 1) ){ // is no exebin
				  for( Idx=0; Idx<128 && (buff[Idx]==32 || buff[Idx]==9) ; Idx++);
				  cn=9; // set a msg
				  ptr=strstr(buff+Idx, "#!");
				  if( ptr ){
					cn=0; Idx=0;
					while(Idx<108 && (ptr[Idx]==32 || ptr[Idx]==9) )Idx++;
					chs=ptr+Idx;
					while(cn<3 && memstr(chs,16,exeScpt[cn],0, 3)==NULL )cn++;
					}
				  if(cn>2)goto _jmp2_; // skip execlp
				  }
				if(fork()==0){
					execlp(fn, fn, NULL );
					char buf[2000];
					sprintf(buf, failToExe, fn, _Spc);
					ManuTxt(-1, buf);
					_exit(1);
					}
				}
			else  {
			_jmp2_:	if(isFsp(fn, false))popFspCons( fn );
				else if(pms_proEditDft)doProEdit(fn, false);
					else {
						sw=-38; Id=1;
						goto _filesor_loop;
					}
				}
			}
		}
		}
	} // switch( isExist(...) )  end
	free(fn);
    }
}

#define _fromUnicode(s)	vStrCodec->fromUnicode(s)

void Filesan::renaming(char *pt, int vw,  bool  pop)
{
char *chs;
bool direct;
int rt;
struct stat64 st;
LVItem  *itm, *it;
it=(modul!=NO_MULT_PANEL) ? (LVItem *)treeview->currentItem() : NULL;
if(direct=(pt==NULL)){
	if(vw){
		if(_filelist==NULL && (IVItem *)_iconview->currentItem()!=renIco)goto _ex2_;
		pt=catstr( dirNam, _fromUnicode(_filelist ? _filelist->currentItem()->text(0) : _iconview->currentItem()->text()),'/');
	}
	else if(it){
		if(modul!=_FASTTAGS)pt=treeFullPath(it, true);
		else { chs=treeview->tagFullPath(it);
			pt=strrchr(chs, '/');
			pt[0]=0;
			pt=catstr(chs, _fromUnicode(it->text(0)),'/');
			free(chs);
		}
	}
}

if(vw==0 && modul==_FASTTAGS && it->parent()==(itm=(LVItem *)treeview->firstChild()) ){
	int t=0, cn, j;
	for(itm=(LVItem *)itm->firstChild(); it!=itm; t++)itm=(LVItem *)itm->nextSibling();
	FastBlock lst(__AppenAlone);
	cn=tagNamlst.count();
	t=cn-1-t;
	for(j=0; j<cn; j++)lst.add( t != j ? tagNamlst.lstIndex(j) : _fromUnicode(it->text(0)) );
	tagNamlst.copy(lst);
	tagNamlst.setLimit();
	if(pms_sorttag)sortTagsList(pms_sorttag);
	else tagNamlst.memDiv(NULL);
	}
else {
	if(strcmp(pt, oldName)==0)goto _ex_;
	if((rt=isExist(pt, &st))!=none_File){
		QApplication::beep();
		chs=catstr(pt, fnamExist,'\n');
		infoWidget(chs, warnChs, normError, this);
		free(chs);
		goto _jmp_;
	}
	if(rename(oldName, pt)){
	 rt=0;
	 statusBarError(renError, pt);
	 if(direct){
_jmp_:		chs=strrchr(oldName,'/')+1;
		if(vw){
			currentView()->setFocus();
			if(_filelist)((LVItem *)_filelist->currentItem())->setText(0, _toUnicode(chs));
			else ( (IVItem *)_iconview->currentItem() )->setText(_toUnicode(chs));
			}
		else it->setText(0, _toUnicode(chs));
	   }
	}
	else {
		chs=strrchr(pt, '/')+1;
		if(vw){
			if(direct||pop)currentView()->setFocus();
		}
		else {
			it->_setName(chs);
			if(direct||pop)it->setText(0, _toUnicode(chs));
			updatePathComb(pt);
		}
	}
	}
if(rt )fsels.resetMem(pt,NULL);
else  _ex_:   free(pt);
_ex2_ :if( !direct)free(oldName);
}

bool Filesan::isFsp(const char *fnam, bool show)
{
   if(fnam){
      struct stat64 st;
      stat64(fnam, &st);
      if( is_dev(st.st_mode) )return false;
      fsp_lib *fsp;
      int i;
      for(i=0; i<SPACELIMIT; i++)
	if(workspace[i]&&strcmp(fnam, workspace[i]->fname)==0){
		fsp=workspace[i];
		goto _jmp_;
		}
      if( (fsp=fspOpen(fnam, DectName)) ){
_jmp_:	if(show)showFspInfo((fsp_dir *)fsp);
	if(i>=SPACELIMIT)fspClose(fsp, NULL);
	return true;
	}
   }
   return false;
}

void Filesan::imageInfo()
{
int idx=(_filelist ? listViewIndex(_filelist, (LVItem *)_filelist->currentItem()) : _iconview->index(_iconview->currentItem())) - vDirCnt;
if(idx>-1){
  ListOptions *f_lo=dno_f_lo.first()+idx;
  const char *fnam;
  if(is_dev(f_lo->mode)||f_lo->icon==ICO_NOREAD||f_lo->icon==ICO_LINKNONE ||
	(fnam=curSelItemPath())==NULL )return;
  if(f_lo->isImg || QImage::imageFormat(QString::fromLocal8Bit(fnam))){
	if( f_lo->siz<3000000){
		appPost(65013, (void *)fnam, this);
		return;
	}
   }
  free((void *)fnam);
}
}

void Filesan::procSelects()
{
   sbar->showMsg(NULL);
   topSbar->showMsg(NULL);
   char *fnam=currentItemPath();
   fspTag=isFsp(fnam, true);
   free(fnam);
   fsels.resetMem(NULL);
   if(_filelist)_filelist->selectedCollect(&fsels, sbar);  // _filelist selectedChange, can use currentItem() ?
   else _iconview->selectedCollect(&fsels);
   objsUpdate();
}

void Filesan::openSelect(const char *pth, const char *nam)
{
showTop(this);
if(strcmp(pth, dirNam)){
	curItemTxt=nam;
	navBtn=1;
	seekPath(pth);
	navBtn=0;
	}
else if(_filelist){
	QListViewItem *it=_filelist->findItem(tranText(strCodec, nam),0, Qt::ExactMatch|Qt::CaseSensitive);
	it->setSelected(true);
	}
           else {
	QIconViewItem *ico=_iconview->findItem(tranText(strCodec, nam), Qt::ExactMatch|Qt::CaseSensitive);
	ico->setSelected(true);
	}
}

bool Filesan::isFspOpera()
{
return modul==_FSPLUS && (isViewOpera()==false || _fsplist->hasFocus() );
}

void Filesan::selectAsSrc(FastBlock &sel, bool add)
{
 if( sel.count()>0 ){
	if(add){
		// sel.memDiv(NULL);
		sel.beAppend(selAsSrc);
		selAsSrc.memDiv(NULL);
		}
	else selAsSrc.copy(sel);
	setCopyStats(selAsSrc.bufferString('\n') );
	}
}

void Filesan::creatAccount(const char *pdir, int img, QString &str, FastBlock *plst, int id)
{
static const un_Int dirpms[pd_param_cnt]={ 0, 12, 6, StocksDAU, 1|2 };
char *nam;
InputDlg dlg(this, id, 0, img);
if(dlg.exe(str, NULL, plst, NULL, NULL)!=0 ) return;
nam=catstr(pdir, str.utf8(), '/');
fsp_dir *dir=pd_creat(selfDir, nam, dirpms);
if(dir)pd_close(dir, 0);
else {
	int i;
	for(i=0; nam[i]; i++);
	nam[i]='/';
	char buf[strlen(nam)+96];
	sprintf(buf, createAccountError, nam, idxdscpt);
	infoWidget(buf, NULL, -1, this);
}
free(nam);
}

QString lifeStr, stocksStr;
const char sig_hl[]=SIGNAL(highlighted(int)),  slot_hl[]=SLOT(showfn(int));

void Filesan::personsMenu(ActMenu *menu, const char *dn, int img, FastBlock &lst, int (*fun)(fsp_dir *pdir, fsp_dir *dir))
{
int i;
fsp_dir *fspdir1=_diropen(selfDir, dn);
if(fspdir1)DirFullBrow(fspdir1, 2, NULL, fun);
else {
	static const un_Int dirpms[5]={ 0, 12, 6, 1, 1|2 };
	char buf[256];
	scopy(buf, dn);
	fspdir1=pd_creat(selfDir, buf, dirpms);
}
pd_close(fspdir1, 2);
menu->clear();
menu->insertItem(*pixmapLoad(newImg), QString::fromUtf8(newAccou), 0);
menu->insertItem(*pixmapLoad(delImg), QString::fromUtf8("Delete Account"), 1);
if(lst.count())menu->insertSeparator();
for(i=0; i<lst.count(); i++)
	menu->insertItem(*pixmapLoad(img), QString::fromUtf8(lst.lstIndex(i) ), i+2);
}

inline int creatFile(const char *fnam)
{
if(access(fnam, F_OK)==0)return 1;
FILE *fp=fopen64(fnam, "wb");
if(fp){
	fclose(fp);
	return 0;
	}
return -1;
}

static const char newDir[]="newdir";
#define  NewDir  83
char *Filesan::createObj(const char *pth, int sw)
{
int  i=1;
if(pth==NULL)pth=dirNam;
char *pt=catstr(pth, sw==NewDir ? newDir : "file.txt", ROOT_CH);
_creat_: if( (sw== NewDir? mkdir(pt, 0755) : creatFile(pt)) ){
	char buf[24];
	free(pt);
	if(i>0x10000 || access(pt, F_OK)==0 ){
		statusBarError(pth, sw==NewDir ? creatDirError : creatFileError);
		return NULL;
		}
	sprintf(buf, sw==NewDir ? "newdir%d" : "file%d.txt", i++);
	pt=sw==NewDir ? catstr(pth, buf, ROOT_CH) : catstr(pth, buf, ROOT_CH);
	goto _creat_;
	}
return pt;
}

void Filesan::addTag(const char *pt)
{
	int t, i;
	if((t=taglst.find(pt))!=-1){
		QApplication::beep();
		char buf[strlen(taglst.lstIndex(t))+strlen(tagNamlst.lstIndex(t))+128];
		sprintf(buf, tagExisted, taglst.lstIndex(t),tagNamlst.lstIndex(t));
		sbar->showMsg(buf, 99, true, 0xab7010);
		return;
		}
	taglst.add( pt );
	const char *tmp=NULL, *chs=strrchr((char *)pt, '/')+1;
	i=0;
	while((t=tagNamlst.find(chs))>-1){
		tmp=chs;
		chs=catstr("new", chs, '_');
		if(i++)free((void *)tmp);
		}
	tagNamlst.add( chs );
	if(pms_sorttag)sortTagsList(pms_sorttag);
	if(modul==_FASTTAGS)treeview->creatTagItem(tagNamlst.find(chs), pms_sorttag);
	if(i)free((void *)chs);
}

char *addlst(const char *fn)
{
char *prg;
int L=strlen(fn);
prg=(char *)malloc(L+3);
scopy(prg+1, fn);
*prg='\"';
prg[L+1]='\"';	prg[L+2]=0;
return prg;
}

LVItem *Filesan::fspListItem()
{
LVItem *it=(LVItem *)_fsplist->curSelItem()->parent();
return it ? it : ((LVItem *)_fsplist->curSelItem());
}

bool Filesan::qt_invoke( int _id, QUObject* _o )
{
int  i=0,  cn, Idx, t=0, sw=_id - staticMetaObject()->slotOffset();
char *chs, *pt;
const char *pth;
bool  vw;
struct stat64 st;
LVItem *itm, *it;
IVItem *ico, *icon;
fsp_dir *fspdir;
_start_:    switch ( sw ) {
    case exeOpens : //  42 => popRightMenu
    case DbClick : //  base num
    case exeOpen :
    case KeyEnter :
         if(CurDirMode&mode_x){
	FastBlock dir1;
	bool tv=modul!=NO_MULT_PANEL&&treeview->hasFocus();
	if(tv)dir1.add(dirNam);
	execProg(sw, search_mdf_wdg==qApp->activeWindow() ? search_mdf_wdg->getFSels() :
		(tv ? &dir1 : &fsels), _o[1].payload.i);
	}
         else sbar->showMsg(no_exec, 50, 1, 0x802020);
	break;
    case IcoViewMous :// ico=(IVItem *)_o[2].payload.ptr; // only iconview, listview in listconnect.*   // mouseEvent
	objsUpdate();
	if(2==_o[1].payload.i)popRightMenu((IVItem *)_o[2].payload.ptr, true); // i=1 left, _iconview->setFocus();
	imageInfo();
	break;
   case 3 :
    case ChangItem :  //  chCurrent.  iconview : chsel => chcur => mouse click
	if(iconDel)break;
    case 78 :
    case SelectAction : //36  _iconview no use this "signal-slot",  listview : chcur => chsel.  not same as iconview
	if( isFspOpera() )IdSelects();
	else {
		if(!_filelist){
		  if(sw!=ChangItem){
			fsels.resetMem(NULL);
			_iconview->selectedCollect(&fsels);
			objsUpdate();
			break;
		  }
		}
		if(CurDirMode&mode_x)procSelects();
		else sbar->showMsg(no_exec, 70, 1, 0x802018);
	}
	break;
    case 59 : // addSelect
    case SelectAsSource : //  =5
	if( isViewOpera() )selectAsSrc(fsels, sw!=5);
	else {
		if(sw!=59)selAsSrc.resetMem( strdup(dirNam) );
		else {
			selAsSrc.add(dirNam);
			selAsSrc.memDiv(NULL);
			}
		setCopyStats(selAsSrc.bufferString('\n') );
	}
	break;
    case 50 : personsMenu(lifeMenu, fspLife, costImg, lifelst, lifeFunc);
	break;
    case 49 : // perantdir
	chs=strdup(dirNam);
	if((pt=strrchr(chs,'/'))!=NULL ){
	  char buff[strlen(pt+1)+2];
	  scopy(buff, pt+1);
	  curItemTxt=buff;
	  navBtn=1;
	  pt[pt!=chs? 0:1]=0;
	  seekPath(chs);
	  navBtn=0;
	}
	free(chs);
	break;
    case 21 : // backBrow
	curItemTxt=curItemList.atList(brwList.index());
	pt=brwList.atList(BACK_BROW);
	goto _set_dir_;
    case 22 : 
	curItemTxt=curItemList.atList(brwList.index()+2);
	pt=brwList.atList(NEXT_BROW);
_set_dir_:	navBtn=2;
	seekPath(pt);
	navBtn=0;
	break;
    case FMOVE : // 34
    case FDUP : // 35
    case FLINK :	// 33 	
    case FCOPY : // 32
	if(selAsSrc.count())new CopyThread(this, this, selAsSrc, dirNam, sw);
	break;
    case 7 : // delete
     it=modul!=NO_MULT_PANEL ? (LVItem *)treeview->currentItem() : NULL;
     if( isFspOpera() ){
	fsp_dir *fspdir=treeview->testFspDir(it);
	if(_fsplist->hasFocus())while(i<Idsels.count()){
		pt=Idsels.lstIndex(i++);
		if(num_del(fspdir, atoi(pt) ) )delete getItem(pt);
	}
	else if(isNormDir(fspdir)){
		fsp_dir *pdir;
		pdir=pdRead(fspdir->lib, NULL, fspdir->parent_adr);
		pt=strdup(fspdir->name);
		t=fspdir->otherOpen;
		pd_close(fspdir, 0);
		if(pdDel(pdir, pt, FSP_rmdir)){
			treeview->treeDel(it);
			treeview->setSelected(treeview->currentItem(), true);
			}
		else {
			fspdir=treeview->itemFspDir(it);
			treeview->setFspDir(fspdir);
			fspdir->lib->CurDir=fspdir;
			fspdir->otherOpen=t; // restore org
		}
		pd_close(pdir, 2);
		free(pt);
	}
    }
    else {
      DelTag=NoDel;
      if(isViewOpera() ){
	FastBlock dels(fsels);
	cn=dels.memDiv(NULL);
	while(i<cn){
		delFile(dels.lstIndex(i), -1, i<cn-1 ? delsInfo:delInfo);
		if( DelTag==CancelDel )break;;
		i++;
		}
	currentView()->setFocus();
//	setCWD(dirNam, DIR_NOTIFY_TOG);
    }
    else  {
	if(delFile(it, 0, deldirInfo)==0){
		treeview->treeDel(it);
		treeview->setSelected(treeview->currentItem(), true);
		}
	}
    }
	break;
    case 6 : // select all
	if(_filelist){
		_filelist->selectAll(true);
		_filelist->setFocus();
		}
	else {
		_iconview->selectAll(true);
		_iconview->setFocus();
		procSelects(); // signal not same, it's 3.38b error
		}
//	selectDoneAct->setEnabled(true);
	deleteAct->setEnabled(CurDirMode&mode_w);
	break;
    case 8 : if(isFspOpera()){ // toggRen
		if(_fsplist->hasFocus()){
			itm=fspListItem();
			_fsplist->clearSelection();
			oldId=atoi( itm->fnam );
			colIdx=0;
			_fsplist->setCurrentItem(itm);
			itm->startRename(0);
			}
		else {
			oldName=strdup(((LVItem *)treeview->currentItem())->fnam);
			treeview->currentItem()->startRename(0);
			}
		}
	else {
	  vw=isViewOpera();
	  if(vw){
		if(_filelist){
			itm=_filelist->curSelItem();
			oldName=listFullPath(itm);
			_filelist->clearSelection();
			_filelist->setCurrentItem(itm);
			itm->startRename(0);
		}
		else {
			renIco=_iconview->curSelIco();
			oldName=viewFullPath(renIco);
			_iconview->clearSelection();
			_iconview->setCurrentItem(renIco);
			renIco->rename();
			}
	  }
	  else {
		oldName=strdup(dirNam);
		treeview->currentItem()->startRename(0);
		}
	}
	break;
    case 10 : // dirview
    case 31 : if(isFspOpera()){
		BOOL rt;
		fsp_dir *dir=treeview->testFspDir((LVItem *)treeview->currentItem());
		if(_fsplist->hasFocus()){
			char bu[200], bu2[128], *pms[4];
			it=fspListItem();
			switch(colIdx){
			case 0 : i=atoi(it->text(0));
				rt=num_ren(dir,oldId, i);
				sprintf(bu, "%d ", rt ? i : oldId);
				if(rt)it->_setName(bu);
				else {
					it->setText(0, bu);
					showMess(NULL);
					}
				break;
			default : pms[3]=NULL; pms[0]=bu; pms[2]=bu2;
				memcpy(bu, it->text(0), 198);
				bu[199]=0;
				fmtvalue(bu, 1);
				memcpy(bu2, it->text(colIdx), 126);
				bu2[127]=0;
				fmtvalue(bu2, 1);
				switch(colIdx){
				case 2 : pms[1]=(char *)"-M";
					chMT(dir,  3, pms, FSP_chmode);
					break;
				case 3 :  pms[1]=(char *)"-T";
					chMT(dir,  3, pms, FSP_chdate);
				}
			}
		}
		else {
			fsp_dir *pdir;
			it=(LVItem *)treeview->currentItem();
			pt=strdup(it->text(0));
			pdir=pdRead(dir->lib, NULL, dir->parent_adr);
			if(pdRen(pdir, oldName, pt))it->_setName(pt);
			else it->setText(0, oldName);
			free(pt);
			pd_close(pdir, 2);
			}
		}
	   else renaming(NULL, sw!=10 ? 1 : 0);
		break;
    case 16 :   // set _filelist column
	if(genSetWdg)showTop((QWidget *)genSetWdg);
	else {
		genSetWdg=new GenSetting(this);
		genSetWdg->getParams(_Params);
		genSetWdg->execu(420, 458, 1);
	}
	break; 
    case 17 : sw=_o[1].payload.i+1;
	if(_filelist){
	    if( sw<=_filelist->columns() ){
		if(sw>0){
		    if(listview_sort != sw )listview_sort=sw;
		    else sort_ascend=!sort_ascend;
		}
		else listview_sort = - listview_sort;
		goto _fresh_view_;
	    }
	}
	else if(sw<=colOptCnt+1){
		if(sw>0){
		    if(iconview_sort != sw )iconview_sort=sw;
		    else sort_ascend=!sort_ascend;
		}
		else iconview_sort = - iconview_sort;
		goto _fresh_view_;		
		}
//	if(sw>43)goto _start_;
	break;
    case 19 : {
	QRect rect=currentView()->geometry();
	mainSplit->setUpdatesEnabled(false);
	if( _filelist ){
		saveListColWidth(_filelist, ColumnWidthsId);
		delete _filelist;
		creatIconView(mainBW)->setGeometry(rect);
	}
	else {
		delete _iconview;
		_filelist=(ListContent *)creatFileList(mainBW, (void *)FileListChs, colOptRslt, useCols, 0);
		_filelist->setGeometry(rect);
	}
	mainSplit->setUpdatesEnabled(true);
	currentView()->show();
	goto _fresh_view_;
	}
	break;
    case 18 : // select tag
    case 15 : // Home
	seekPath(sw!=18 ?  home  : taglst.lstIndex(_o[1].payload.i));
	break;
    case 30 : // chPathComb, list drag & click to select one
	updatePluzone(true);
	break;
     case 2 : {
	FileAttrib  *fRslt=(FileAttrib  *)zalloc(sizeof(FileAttrib)); //new FileAttrib;
	int msg;
	fRslt->inView=isViewOpera() ? 1 : 0;
	if(fRslt->inView)pt = curSelItemPath();
	else {
		pt=strdup(dirNam);
		if(modul==_PLACE){
			Idx=listViewIndex( treeview,  (LVItem *)treeview->currentItem())+1;
			if(Idx>0){
			  int L=strlen(pdklst.lstIndex(0)), L1=strlen(pdklst.lstIndex(Idx)), C;
			  char cap[L+4];
			  static const char div[]=",";
			  scopy(cap, pdklst.lstIndex(0));
			  fmtinp(cap, NULL, " \t", ',');
			  FastBlock caplst(cap, div, NoFree), lst;
			  lst.add(pdklst.lstIndex(Idx), div);
			  C=lst.count();
			  char tmp[L+L1+C*10+8];
			  tmp[0]=0;
			  while(i<C){
				strcat(tmp, caplst.lstIndex(i));
				strcat(tmp, " : ");
				strcat(tmp, lst.lstIndex(i++));
				strcat(tmp, "<br/>");
			  }
			  fRslt->pExt=strdup(tmp);
			}
		}
	}
	while(i<attWdgs.count()){
		if(strcmp(attWdgs.at(i)->pathnam(),pt)==0){
			showTop((QWidget *)attWdgs.at(i));
			free(pt);
			free(fRslt);
			return false;
		}
		i++;
	}
	msg=stat64(pt, &fRslt->sb);
	if( fRslt->inView )fRslt->sels.copy(fsels);
	else {
		fRslt->xOld=isExecable(u_id, g_id, &fRslt->sb);
		fRslt->rOld=isReadable(u_id, g_id, &fRslt->sb);
	}
	fRslt->lostLnk=(msg && access(pt, F_OK));
	fRslt->fn=pt;
	fRslt->isDir = msg ? false : S_ISDIR(fRslt->sb.st_mode);
	FileAtt *attDlg=new FileAtt(this, fRslt);
	attDlg->execu( 400, fRslt->isDir ? 468 : 436, 2);
	}
	break;
    case 13 :
    case 28 : if(isFspOpera()){
		FILE *fp=tmpfile();
		if(fp==NULL)break;
		fsp_dir *dir=treeview->testFspDir((LVItem *)treeview->currentItem());
		BYTE *stat=seekFCU(dir, atoi(fspListItem()->fnam),NULL, NUMB_READ);
		if(stat==NULL)	// qWarning("%s seek numb %s", dir->name, ((LVItem *)_fsplist->currentItem())->fnam );
			break;
		readTo(dir, stat, isType(dir->Format), dir->DAUC, fp);
		free(stat);
		unsigned int len=ftell(fp);
		rewind(fp);
		pt=(char *)malloc(len+2);
		fread(pt,len,1,fp);
		fclose(fp);
		pt[len]=0;
		fspX=this;
		fspZone=(FspCon *)this;
		writeCon(dir, pt);
		}
	     else {
//		fsels.memDiv(NULL);
		while( i<fsels.count() )
			doProEdit(fsels.lstIndex(i++), sw==13 );
		}
	break;
    case 74 : 
    case 75 :
	fspdir=treeview->testFspDir((LVItem *)treeview->currentItem());
 	pt=currentItemPath();
	sprintf(InpBuf, sw!=75 ? "exe %s" : "import %s", pt);
	free(pt);
	goto _comrun_;
    case 73 : //zoredir
    case 43 :
    case NewDir : if( isFspOpera() ){
	if( (fspdir=treeview->testFspDir((LVItem *)treeview->currentItem()))==NULL)
		break; // 防快速键失误
	if(sw!=43){
	   char buf[32];
	   scopy(buf, newDir);
_testdir_:   if(seekFCU(fspdir, 0, buf, DIR_READ)==NULL){
		pt=pdPathNam(fspdir, NULL, 0);
		chs=catstr(pt, buf, '/');
		free(pt);
		if(sw!=73)sprintf(InpBuf, "mkdir %s", chs);
		else sprintf(InpBuf, "mkdir %s -z", chs);
		free(chs);
		goto _comrun_;
	   }
	   else if(t<0x10000){
		sprintf(buf, "%s%d", newDir, ++t);
		goto _testdir_;
		}
	}
	else {
		scopy(InpBuf, "write");
_comrun_:	void *zone=fspZone;
		fspZone=(FspCon *)this;
		fspX=this;
		comRun(isNormDir(fspdir) ? fspdir->lib : (fsp_lib *)fspdir, InpBuf, 0, NULL);
		fspZone=(FspCon *)zone;
		if(sw==NewDir || sw==73)treeview->selFspDir((LVItem *)treeview->currentItem(), NULL, 2);
		}
	}
	else {
		pt=createObj(dirNam, sw);
		if(pt){
			newMsg=true;
			free(pt);
		}
		currentView()->setFocus();
	}
	break;
    case 58 :	panelRightBtn->setOn(pms_panelRight=!pms_panelRight);
		one->setUpdatesEnabled(false);
		multfunPanel->hide();
		mainSplit->hide();
		if(!pms_panelRight)one->moveToFirst(multfunPanel);
		else one->moveToFirst(mainSplit);
		multfunPanel->show();
		mainSplit->show();
		one->setUpdatesEnabled(true);
		break;
    case 63 : 
	if( modul!=NO_MULT_PANEL ){
		confMenu->removeItem(dirNoSortId);
		pms_orgModul=modul;
		modul=NO_MULT_PANEL;
		if(pms_orgModul==_FSPLUS)delete fspView;
		multRect=multfunPanel->geometry();
		curViewRect=currentView()->geometry();
		delete multfunPanel;
		}
	else {
		fsKillTimer();
		one->setUpdatesEnabled(false);
		modul=pms_orgModul;
		one->hide();
		creatMultPanel(&multRect);
		setDirNoSort();
		currentView()->setGeometry(curViewRect);
		one->show(); // must both show to count size
		modulsInit(false);
		if(modul==_FSPLUS)creatFspList();
		one->setUpdatesEnabled(true);
		fsStartTimer();
		}
	break;
    case 62 :// treeview->tagsSort(_o[1].payload.i);
     if(_o[1].payload.i==0){ // no sort
	taglst.memDiv(NULL);
	tagNamlst.memDiv(NULL);
	pms_sorttag=0;
//	goto _creatTags_;
	}
      else {
	switch(pms_sorttag){
	case 1 : 
	case 0 : pms_sorttag=-1;
		break;
	case -1 : pms_sorttag=1;
	}
	sortTagsList(pms_sorttag);
	}
	if(modul==_FASTTAGS)treeview->sortTagsItem();
	break;
    case 23 : static const char slot_tagSort[]=SLOT(tagSort(int));
	if(tagCount)
	    for(cn=0;cn<tagCount+6;cn++)tagMenu->removeItemAt(1);
	tagCount=taglst.count();
	if(tagCount){
	  tagMenu->insertMenu( tagRemImg, tagRemChs, this, SLOT(delTag()), 0, 62980);
	  switch(pms_sorttag){
	  case 0 : i=tagOrgImg;
		break;
	  case -1 : i=tagSortAImg;
		break;
	  case 1 : i=tagSortDImg;
	  }
	  tagMenu->setItemParameter(
		tagMenu->insertMenu( i, tagSortChs, this, slot_tagSort,0, 629801), 1 );
	  tagMenu->setItemParameter(
		/*i= */tagMenu->insertMenu( -1, tagSortTimeChs, this, slot_tagSort,0, 629802 ), 0);
	  tagMenu->setItemEnabled(629802,  pms_sorttag);
	  tagMenu->insertSeparator();
	  connect(tagMenu, sig_hl, this, slot_hl );
	  for( i=tagCount-1; i>-1; i-- ){
		pth=taglst.lstIndex(i);
		cn=tagMenu->insertItem( strcmp(home, pth) ? *selectTagPix(filePixmap(pth)) : *freqPix[ICO_HOMEDIR],
		vStrCodec->toUnicode( tagNamlst.lstIndex(i) ), this, SLOT(seltag(int)), 0, 63000+i );
		tagMenu->setItemParameter(cn,  i );
		}
	  tagMenu->insertSeparator();
	  tagMenu->insertItem(*pixmapLoad(delImg), QString::fromUtf8(clearAllTags), this, SLOT(clearTag()) );
	}
	break;
     case 0 : i=_o[1].payload.i;
	if(i>62999 && i < 63000 + taglst.count() )sbar->showMsg( taglst.lstIndex(i-63000) , 40 );
	else sbar->showMsg(NULL/*_Spc, 0xa00*/);
	break;
     case 24 :
	if(isViewOpera()||modul==_FASTTAGS){
		struct stat64 st;
//		t=fsels.memDiv(NULL);
		while(i<fsels.count()){
			pt=fsels.lstIndex(i++);
			stat64(pt, &st);
			if(S_ISDIR(st.st_mode)==false)strrchr(pt, '/')[0]=0;
			addTag(pt);
			}
		}
	else addTag(dirNam);
	break;
     case 25 : {
	ActMenu pop(this);
	connect(&pop, sig_hl, this, slot_hl );
	for( i=tagCount-1; i>-1; i-- ){
		cn=pop.insertItem( *selectTagPix(filePixmap(taglst.lstIndex(i)) ),
			vStrCodec->toUnicode( tagNamlst.lstIndex(i) ), this, SLOT(RemTag(int)), 0, 63000+i );
		pop.setItemParameter(cn,  i );
		}
	pop.exec( cursor().pos() );
	break;
	}
     case 26 : Idx=_o[1].payload.i;
	if(modul==_FASTTAGS){
		itm=(LVItem *)treeview->firstChild()->firstChild();
		while(i++ < taglst.count()-1-Idx )itm=(LVItem *)itm->nextSibling();
		}
	goto _delTag_;
     case 12 : it=(LVItem *)treeview->firstChild()->firstChild(); // deleteTag
	itm=(LVItem *)treeview->currentItem();
	while(it!=itm){
		i++;
		it=(LVItem *)it->nextSibling();
	}
	Idx= taglst.count()-i-1;
_delTag_:if(taglst.count()>1){
	   if(modul==_FASTTAGS)treeview->treeDel(itm);
	  taglst.rem(Idx);
	  tagNamlst.rem(Idx);
	  if(pms_sorttag)sortTagsList(pms_sorttag);
	  break;
	}

     case 9 : taglst.resetMem(NULL);
	tagNamlst.resetMem(NULL);
_creatTags_:	if(modul==_FASTTAGS)treeview->createTags();
	break;
     case 4 : fsplusLink(this, _o[1].payload.i, 2);
	break;
     case 61 : menubrows.resetMem(NULL);
	break;
     case 11 : menulst.resetMem(NULL);
	break;
    case 1 : showHide=!showHide;
	 confMenu->setItemChecked(showHideId, showHide);
_fresh_view_:	setCWD(dirNam, RESHOW_LIST, NULL);
	break;
    case 14 :  // fresh dir
_fresh_tv_:	//if(modul==NO_MULT_PANEL)goto _fresh_view_;
//	freshDirItem((LVItem *)treeview->currentItem());
	updatePluzone(true);
	break;
    case 51 : {
	SimpleImage *gse=new SimpleImage(this);
	gse->exe(currentItemPath());
	}
	break;
    case 45 : if( (brwImg=browImageBtn->isOn()) )goto _fresh_view_;
	break;
    case 46 : // RENCASE0
    case 47 : // RENCASE1
	if(isViewOpera() ){
	     if(infoWidget(Selecting, NULL, renCaseAll, this)==doContinue){
//		t=fsels.memDiv(NULL);
		while(i<fsels.count())
			__operaDir(this, sw, fsels.lstIndex(i++), Filter, NULL);
		procSelects();
	     }
	}
	else {
	     if( infoWidget(dirNam, NULL, renCaseAll, this)==doContinue )
		__operaDir(this, sw, dirNam, Filter, NULL);
	}
	break;
    case 44 : chs=curSelItemPath();
	runFilesan(chs);
	if(chs)free(chs);
	break;
    case 20 : pt=menubrows.lstIndex(_o[1].payload.i);
	if(menuClickStat&ShiftButton)doProEdit(pt,false);
	else browsHtml(this,pt, menuClickStat&Qt::ControlButton);
	menuClickStat=0;
	break;
    case 53 : doProEdit(menulst.lstIndex(_o[1].payload.i), menuClickStat&Qt::ControlButton);
	menuClickStat=0;
	break;
    case 52 : pms_case=!pms_case;
	confMenu->setItemChecked(caseId, pms_case);
	switch(modul){
	case _FASTTAGS :
	case _PLACE :
	case _FSPLUS :
	case NO_MULT_PANEL : setCWD(dirNam, SHOW_LIST );
		if(modul==NO_MULT_PANEL)break;
	case _OSROOT : treeview->treeSort(SHOW_TREE_LIST);
	}
	break;
    case 48 : toolPanelBtn->setOn(pms_toolPanelLeft=!pms_toolPanelLeft);
	multPanelResize(dirBW);
	break;
    case 64 : QMessageBox::aboutQt(this, "About Qt");
	break;
    case 65 : loadSearchModify(this);
	break;
    case 66 : vStrCodec=_setCodec(_viewCodec=_o[1].payload.i);
	strCodec=vStrCodec;
	setCurCodeVal();
	if(pms_prgDefaultCodec!=-1)pms_prgDefaultCodec=_viewCodec;
	setMenuChk(codecMenu, subCode, bakCodec, false);
	bakCodec=_viewCodec;
	setMenuChk(codecMenu, subCode, _viewCodec, true);
	codecMenu->setItemChecked(defCode, pms_prgDefaultCodec!=-1&&_viewCodec==pms_prgDefaultCodec);
	while(i<proEditList.count())proEditList.at(i++)->setTitle();
	goto _fresh_tv_;
    case 54 : if(pms_prgDefaultCodec!=-1)pms_prgDefaultCodec=-1;
		else pms_prgDefaultCodec=_viewCodec;
		codecMenu->setItemChecked(defCode, pms_prgDefaultCodec!=-1&&_viewCodec==pms_prgDefaultCodec);
	break;
    case 57 : fsp_dir *dir;
	char buf[160];
	i=_o[1].payload.i;
	if(i==0){
		chs=getenv(langEnv);
		if(chs){
			pt=buf+128;
			for( t=0; chs[t]!='.'&&chs[t]; t++)buf[t]=chs[t];
			buf[t]=0;	scopy(pt, buf);
		}
		else break;
		}
	else {
		scopy(buf, pt=langlst.lstIndex(i-1));
		i++; // for langMenu->idAt(i)
		}
	chs=catstr(langDir, buf, '/');
	dir=DirOpen(fspRoot, chs);
	free(chs);
	if(dir){
		MAU mau;
		pd_close(selfDir, 2);
		selfDir=dir;
		mau.buf=buf;
		mau.len=0;	mau.alen=0;
		numbWrite(fspRoot, languageId, &mau, 1);
		langMenu->setItemChecked(langId, false);
		langMenu->setItemChecked(langId=langMenu->idAt(i), true);
		sprintf(buf, chlang, pt);
		sbar->showMsg(buf , 90);
		dir=_diropen(selfDir, Descript);
		pd_close(descript, 0);
		descript=dir;
		}
//	else sprintf(buf, nolang, chs);
	break;
    case 60 : {
	fsp_dir *dir=DirOpen(selfDir, fspStocks);
	if(pdDel(dir, stockslst.lstIndex(_o[1].payload.i), FSP_rmdir))
		stockslst.rem(_o[1].payload.i);
	pd_close(dir, 1);
	}
	break;
    case 55 : showLog(this, copyInfoList, cpLogImg, cpInfoChs);
	break;
    case 67 : pt=currentItemPath();
	if(pt){
		popFspCons( pt );
		free(pt);
	}
	break;
    case 68 : {
	PersonLog *log=new PersonLog(this);
	if(log->exe(plogChs, 10, 4, _filesor_+Int_logCols, personLogImg )==false)delete log;
	}
	break;
    case 69 : cn=_o[1].payload.i;
	switch(cn){
	case  0 : creatAccount(fspStocks, stocksImg, stocksStr, p_stocklst, 2);
		break;
	case 1 : {
		ActMenu pop(this);
		for( i=stockslst.count()-1; i>-1; i-- ){
		    cn=pop.insertItem( *pixmapLoad(stocksImg),
			vStrCodec->toUnicode( stockslst.lstIndex(i) ), this, SLOT(delStock(int)));
		    pop.setItemParameter(cn,  i );
		}
		pop.exec( cursor().pos() );
	break;
	}
	default : {
		FinaStocks *stocks=new FinaStocks(this);
		if(stocks->exe(stockslst.lstIndex(cn-2), 12, 3, _filesor_+Int_stockCols,
			stocksImg)==false)delete stocks;
		}
	}
	break;
    case 70 : cn=_o[1].payload.i;
	switch(cn){
	case 0 : creatAccount(fspLife, costImg, lifeStr, p_lifelst, 4);
		break;
	case 1 :/* qWarning("delete");*/ break;
	default : {
		GenLife *life=new GenLife(this);
		if(life->exe(lifelst.lstIndex(cn-2), 11, 2, _filesor_+Int_lifeVal, gendateImg)==false)delete life;
		}
	}
	break;
    case 71 : personsMenu(stocksMenu, fspStocks, stocksImg, stockslst, stocksFunc);
	break;
    case 72 : pms_onlyFile=!pms_onlyFile;
	goto _fresh_view_;
    case 76 : 
	pt=menuPlus.lstIndex(_o[1].payload.i);
	if(qApp->activeWindow()==this){
		fsp_lib *lib=fspSpace(pt, (OpenSpace)(CompactMsg|FspError), -1);
		if(lib){
			treeview->setRecent(lib);
			fsptm=6;
			if(Fsp_Zone)Fsp_Zone->updateZone(lib);
		}
	}
	else popFspCons( pt );
	break;
    case 77 : // clearFsp,
	menuPlus.resetMem(NULL);
	break;
   case 80 : colIdx=2;
	fspListItem()->startRename(2);
	break;
   case 81 : colIdx=3;
	fspListItem()->startRename(3);
	break;
   case 82 : _iconview->hide();
	_iconview->show();
	_iconview->setFocus();
	break;
   case 56 : popFspCons( pluzone );
	break;
   case 79 :
	if(++vNotifyTM>3){
		if(vNotifyMsg){
			vNotifyMsg=false;
			vNotifyTM=0;
			break;
		}
		if(notifying){
			vNotifyTM=0;
			break;
		}
		delete notifyTimer;
		notifyTimer=NULL;
		notifying=true;
		vNotifyMsg=true;
		setCWD(dirNam, DIR_NOTIFY_TOG);
		notifying=false;
	}
	break;
    case 29 : // don't change 27, 29
    case 27 : if(selAsSrc.count()){
		if( (chs=curSelItemPath()) ){
			struct stat64 st;
			if(stat64(chs, &st)==0 && isWritable(u_id,g_id, &st) )
				new CopyThread(this, this, selAsSrc, chs, sw-27+FCOPY);
		}
		free(chs);
	}
	break;
    case 86 : {
	QDropEvent *e=(QDropEvent *)_o[1].payload.ptr;
	if(canDrop(e, dirNam))
		procDrop(this, this, e, dirNam); // iconView drop
	else sbar->showMsg(DropSelf, 30, true, 0x9a2420);
	}
	break;
    case 84 : 
    case 85 : 	i=sw-84;
	if(infoWidget(NULL,NULL, SysCmd_reboot+i, this))break;
	sysCmdId=i;
	QApplication::postEvent( qApp, new QCloseEvent );
	break;
    case 88 :
    case 87 : topSbar->showMsg(decompressing, 0, 1, 0xa03028);
	goto _post_;
    case 96 :
    case 95 : //	if(isViewOpera()==false)fsels.resetMem(strdup(dirNam));
    case 94 :
    case 93 : ar_engIdx= sw!=94 &&sw!=96 ? 0 : _o[1].payload.i;
	goto _Post_;
    case 92 :
    case 91 : // if(isViewOpera()==false)fsels.resetMem(strdup(dirNam));
    case 90 : 
    case 89 : ar_engIdx= sw!=90 &&sw!=92 ? 0 : _o[1].payload.i;
_Post_:	topSbar->showMsg(compressing, 0, 1, 0xd02010);
_post_:	appPost(65000+sw, NULL, this);
	break;
    case 97 : {
	FastBlock vdir;
	if( ! isViewOpera() ){
		if(modul==_FSPLUS)break;
		vdir.add(dirNam);
		}
	CopyThread dirsum(this, this, vdir.count() ? vdir : fsels, NULL, EXE_COUNT);
	}
	break;
     default : return QMainWindow::qt_invoke( _id, _o );
    }
    return TRUE;
}

