/*
    LinJiangHua (xempo) write in 2011, 2014, 2015
    Free under LGPL
*/

#ifndef	LIST_CONTENT
#define	LIST_CONTENT
#include <qlistview.h>
#include "fastblock.h"
#include "pluzone.h"

class Filesan;
class QTextCodec;
class StatusPanel;

extern const char 	showY[], showN[],
	treeViewChs[], FindListChs[], FileListChs[], OptListChs[], LnkTogListChs[], personListChs[], fspListChs[];

enum ListType { T_TreeView, T_FileList, T_OptList, T_LnkTogList, T_FspList, T_SearchList, T_PersonList };

class LVItem : public QListViewItem
{
public :
LVItem(LVItem *p, const QString txt);
LVItem(QListView *view, const QString txt);
LVItem(QListView *view, LVItem *after, const char *txt, QTextCodec *code=NULL, bool isDir=true);
LVItem(LVItem *p, LVItem *after, const char *txt, QTextCodec *code=NULL);
// above would be use dir

LVItem(QListView *view, LVItem *after, int T=0);
LVItem(LVItem *p, LVItem *after);
~LVItem();

void _setName(const char *nam);
char *fnam;
bool isDir() const
{ return _dir; }

unsigned int getType() const
{ return type; }

void setType(unsigned int t)
{ type=t; }

unsigned int getTypeOr() const
{ return (type&255); }

void setTypeOr(unsigned int t){ type = type & (~((unsigned int)255)) | t; }

protected :
virtual void paintCell( QPainter *p, const QColorGroup &, int col, int width, int align);

private :
unsigned int type;
bool _dir;
};

class ListContent : public QListView
{
public :
ListContent(QWidget *wdg, const char *name, int id, Filesan *fsn);
void selectedCollect(FastBlock *fsel, StatusPanel *sbar);

LVItem *Index(int idx);
int getId() const
{
return Id;
}

LVItem  * curSelItem();

protected :
Filesan *filesor;
int dropTim, Id, lostId;

bool event(QEvent *);
virtual  void contentsDragEnterEvent( QDragEnterEvent *e );
virtual  void contentsDragMoveEvent( QDragMoveEvent *e );
virtual  void contentsDragLeaveEvent( QDragLeaveEvent *e );
virtual  void contentsDropEvent( QDropEvent *e );
// 以上是QScrollView成员，由QDragObject中的成员drag启动

virtual  void contentsMouseMoveEvent( QMouseEvent *e );
virtual  void contentsMousePressEvent( QMouseEvent *e );
virtual  void contentsMouseReleaseEvent( QMouseEvent *e );

private :
char *itemFullName(LVItem *);
void endTimer();
int adjDrop(LVItem *);
bool isTagsRoot(LVItem *it);
QStrList getDirName(LVItem *);
bool pressMouse, itemCanDrop, copyAction;
int  tms;
QPoint presspos;
LVItem  *stayItem, *oldItem, *dropMeet,
*diskItem;// show mountinfo when mous move on
};

extern char *treeFullPath(LVItem *it, bool renMsg=false);

extern bool canDrop(QMimeSource *e, const char *dst);

#define	 __from_unicode(s) strCodec->fromUnicode(s)

// extern bool pressHalt;

#endif

