/*
    林江华编写，2010年2月，
    Copyright LinJiangHua 2010-2015
    Free under LGPL
*/

#include <qapplication.h>
#include "fspdir.h"
#include "fspio.h"
#include "conspace.h"
#include "init.h"
#include "write.h"
#include "rebuild.h"

#include "options.h"
#include "filesan.h"
#include "xfunc.h"
#include "pluzone.h"
#include "fspattr.h"
#include "fspcon.h"
#include "extfunc.h"
#include "../rtdata/en/target/filesor.h"

#include "actmenu.cpp"

extern void (*pChMT)(fsp_dir *, int msg);

extern QStringList smLogList; // searchmodify.cpp

StrList pathList;

int langIdx=98;
const char langDir[]="Language", Descript[]="descript", listdir[]="List",
	*_homeUnder, *_homeName;

const char langEnv[]="LANG", 
	*pluzonecwd, **p_countChs=(const char **)listdir;
QApplication *qApp;

inline void doEnvPaths(char **argv)
{
  int len, ln, b, t,  n=0;
  char *src, *pth, *pt;
//  envpaths.memDiv(":,");
  if( (pt=strrchr( *argv, '/'))!=NULL &&pt != *argv ){
	*pt=0;
	// if(strcmp(*argv, "."))
	envpaths.add(*argv);
	}
  while( n<envpaths.count() /* use dyn */){
     if( (pt=strstr(src=envpaths.lstIndex(n), "$(" )) !=NULL ){
         len=strlen(src);
         ln=len-(pt-src);
         for(b=0;pt[b]!=')'&&b<ln; b++);
         if(b<ln){
	char keyword[b+2];
	b-=2;
	for(t=0; t<b; t++)keyword[t]=pt[2+t];
	keyword[b]=0;
	pth=getenv(keyword);
	if(pth){
	  ln=strlen(pth);
	  char dat[ len+ln-b+2 ];
	  scopy(dat,src);
	  len=pt-src;
	  scopy(dat+len,pth);
	  scopy(dat+len+ln,pt+b+3);
	  envpaths.rem(n);
	  fmtinp(dat+1, NULL, "/", '/');
	  envpaths.add(dat);	
	}
	}
     }
      n++;
  }
/* --------------- sys-path -------------*/
  pth=strdup(getenv("PATH"));
  fmtinp(pth+1, NULL, "/", '/');
  FastBlock tmp(pth,":,");
  for(t=0; t<tmp.count(); t++)envpaths.add(tmp.lstIndex(t));
/* ------------- can't optiom -------------- */
  envpaths.add(home);
  envpaths.add(pcwd);
  envpaths.setStrList(&pathList);
// for(t=0; t<envpaths.count(); t++)qWarning(envpaths.lstIndex(t));
}

void *_numbRead(int id, int sz)
{
MAU mau;
if(numbRead(fspRoot, id, &mau, 1, false)>-1)return mau.buf;
else return zalloc(sz*menulst.limit());
}

void sortTagsList(int sort)
{
FastBlock lst(__AppenAlone);
tagNamlst.memDiv(NULL);
taglst.memDiv(NULL);
lst.copy(tagNamlst);
int i, cn=lst.memDiv(NULL);
tagNamlst.sort(sort>0, __params[30]/* case */);
char *pts[cn];
if(sort>0){
	i=0;
	while(i < cn)pts[i++]=taglst.lstIndex( lst.find(tagNamlst.lstIndex(i)) );
	}
else {
	i=cn-1;
	while(i >-1)pts[i--]=taglst.lstIndex( lst.find(tagNamlst.lstIndex(i)) );
	}
taglst.setPlist(pts);
}

int main(int argc, char **argv)
{
uId=getuid();
gId=getgid();
pcwd=getenv("PWD");
home=getenv("HOME");
// if(home==gettatic ); static !!
QApplication app(argc, argv);
qApp=&app;
int n, rt=1;
char *pt;
_homeUnder=strdup(home);
pt=strrchr((char *)_homeUnder, '/');
_homeName=pt+1;
if(pt!=_homeUnder)*pt=0;
else _homeUnder="/";

popMsg=popInfo;
msgShow=showMess;
getMsg=getMess;
PrnTxt=outText;
consWrite=writeCon;
extDest=menuPlusDo;
pChMT=getDirNam;
// if( (n=init(&argc, argv, "--lang"))==ini_notfsp)return -1;
Filesan *filesor=new Filesan(NULL, init(&argc, argv, "--lang")); // use new because construct with WidgetFlags=...|Qt::WDestructiveClose	
fspX=filesor;

pt=(char *)fspFileName("pluzone-1.4.2", ".pluzone-1.4.2", "/usr/share/pluzone-1.4.2", &rt, &pluzonecwd);
if(rt>ini_first){
	char buf[320];
	sprintf(buf, pInfo, pt );
	infoWidget(buf, NULL, -1, filesor);
	return rt;
}
	
fsplib=fspSpace(pt, (OpenSpace)(OpenAlway|HasFullPath|FastBuf), -1);
if(fsplib==NULL){
    infoWidget(catstr(pt, "Unknow the file format !", '\n'), NULL, -1, NULL);
    return ini_notfsp;
}

// free(pt); becasue (msg|HasFullPath), lib->fname=pt;
screenHeight=QApplication::desktop()->size().height();
screenWidth=QApplication::desktop()->size().width();
  MAU mau;
  fsp_dir *list;
  static char dfLang[]="en\00";
  fspRoot=(fsp_dir *)fsplib;
  numbRead(fspRoot, colOptId, &mau, 1, true);
  colOptRslt=mau.buf;
   numbRead(fspRoot, 0, &mau, 1, true);
   __params=(int *)mau.buf;

  {
  char *txt=NULL, buf[128];
#define mu1  6
#define inv1  5
	static const char *mu1chs[mu1]={ "-C", "-P", "-T", "-S", "-N", "-H" },
	*_mu1chs[mu1]={ "--computer", "--place", "--tag",  "--star", "--nopanel", "--help" };
	int mu1val[mu1];
	static const int mu1inv[inv1]={ 0, 1, 2, 3, 4 }; // "--computer", "--place", "--tag",  "--star", "--nopanel" can't use togetther

#define  mu2  2
#define inv2  0
	static const char *mu2chs[mu2]={"-L", "-F" },*_mu2chs[mu2]={ "--language", "--filter" };
	int mu2val[mu2];

 memset(mu1val, 0, sizeof(int)*mu1);
 memset(mu2val, 0, sizeof(int)*mu2);
 ProcOpt opt1={	mu1,	mu1chs, _mu1chs,	mu1val,	inv1,	mu1inv	},
	opt2={	mu2,	mu2chs, _mu2chs,	mu2val,	inv2,	NULL	};
  char **pms=argv+1, *dnam=NULL;
  arglists *lst=procParas(argc-1, pms, &opt1, &opt2);
  bool hlp=false;
  if(lst){
     int i, a;
     if(lst->argc>0)dnam=lst->argv[lst->argc-1];
     for(i=0; i<opt1.argc; i++)
	if(opt1.rtval[i]){
		switch(i){
		case 5 : hlp=true;
			break;
//		case 6 :
		default : __params[35]=i; //filesor->setModul(i); pms_multPanel
		}
	}
     for(i=0; i<opt2.argc; i++)
        if( (a=opt2.rtval[i]&0x7fff) )
	switch(i){
	case 0 : txt=lst->subarg->argv[0];
		break;
	case 1 : filesor->setFilter(strdup(lst->subarg->argv[1]));
//	case 2 :  argv[a+1];
	}
     argsFree(lst);
   }
   if(txt)n=-1;
   else {
      n=numbRead(fspRoot, languageId, &mau, 1, false);
      if(n>-1)txt=mau.buf;
      else {
	char *chs=getenv(langEnv);
	if(chs){
		int t;
		for( t=0; chs[t]!='.'&&chs[t]; t++)buf[t]=chs[t];
		buf[t]=0;	buf[t+1]=48;
		txt=buf;
		langIdx=0;
	}
	else txt=dfLang;
	}
   }

_re_cat_:   pt=catstr(langDir, txt, '/');
   selfDir=_diropen(fspRoot, pt);
   free(pt);
   if(n>-1)free( txt );
   if(selfDir==NULL&&txt!=dfLang){
	txt=dfLang;
	goto _re_cat_;
	}
   if(numbRead(fspRoot, passwdFile, &mau, 1, true)>-1) {
	usrList=getLogors(mau.buf, &usrIDs);
	free(mau.buf);
   }
   if(numbRead(fspRoot, groupFile, &mau, 1, true)>-1) {
	grpList=getLogors(mau.buf, &groupIDs);
	free(mau.buf);
   }
// rt=0;
   if(list=_diropen(fspRoot, listdir)){
	numbRead(list, 0, &mau, 1, true);
	pt=mau.buf; // list limit
	for(n=0; n<ListCount; n++){
		_List[n].setLimit(pt[n]);
		if(numbRead(list, n+1, &mau, 1, false)>-1){
			_List[n].getFromMau(&mau);
			_List[n].memDiv(NULL);
			if(n==20)_List[20].setMode(CombList); // fspZone
	}
	}
	pd_close(list,0);
	free(pt); // list limit
	if(taglst.count()==0){
		taglst.add(home);
		tagNamlst.add("Home");
		}
	}
   doEnvPaths(argv);
   iconDir=_diropen(fspRoot, "icons");
   for(n=0; n<freqIcons; n++)
	freqIco[n]=new QPixmap(*pixmapLoad(fileImg+n));

   _filesor_=charsFromFSP(0);
   colName=_filesor_+Int_columnName;
   p_countChs=_filesor_+Int_countChs;
   cpListCols=_filesor_+Int_cpVList;
   if( __params[11]/*pms_sorttag*/)sortTagsList(__params[11]);

   descript=_diropen(selfDir, Descript);
   filesor->exec(dnam);
   if(hlp)fsplusLink(filesor, 10, 2/* newWidget */);
  }
  menuFilesPos=(file_pos *)_numbRead(filesPosId, sizeof(file_pos));
  menuWdgsSiz=(file_pos *)_numbRead(proEditSizeId, sizeof(file_pos));
  menuIsMaxs=(char *)_numbRead(isMaxId, 1);
  FileAssoc=_diropen(selfDir,"FileAssoc");
  app.connect(&app, SIGNAL(lastWindowClosed()), &app, SLOT( quit() ) );
  rt=app.exec();
  mau.buf=(char *)__params;	mau.len=fs_params_count*sizeof(int); mau.alen=0;
  numbWrite(fspRoot, paramsId, &mau, 1);
  n=menulst.limit();
  mau.buf=(char *)menuFilesPos;	mau.len=n*sizeof(file_pos);
  numbWrite(fspRoot, filesPosId, &mau, 1);
  mau.buf=(char *)menuWdgsSiz;	mau.len=n*sizeof(file_pos);
  numbWrite(fspRoot, proEditSizeId, &mau, 1);
  mau.buf=(char *)menuIsMaxs;	mau.len=n*2; // one : isMax, other : _codec
  numbWrite(fspRoot, isMaxId, &mau, 1);
  list=_diropen(fspRoot, listdir);
  static const int preLens[ListCount-3]={ 400,400,160,160,400,300,250,250,320,80,160,160,80,160,120,120,400,300,400,300, 400,400, 400  };
  for(n=3; n<ListCount; n++){
	if(_List[n].count()==0)num_del(list, n+1);
	else {
		_List[n].setMau(&mau);
		mauAlen(mau, preLens[n-3], 80);
		numbWrite(list, n+1, &mau, 1);
	}
  }
//	pd_close(list, 0);	pd_close(descript, 0);	pd_close(FileAssoc, 0);	pd_close(selfDir, 0);
  if(copyInfoList.count())saveLog(catstr(pluzonecwd, "cpError.log", '/'), copyInfoList);
  if(smLogList.count())saveLog(catstr(pluzonecwd, "searchmdf.log",'/'), smLogList);
  for(n=LASTSPACE; n>-1; n--)if(workspace[n])fspClose(workspace[n], fspRebuild);
  if(sysCmdId>-1){
	static const char syscmd[2][7]={ "reboot", "halt" },
	*syspms[2]={NULL, "-p" },
	sysMsg[2][22]={ "Can't restart system", "Can't shutdown system"};
	execlp(syscmd[sysCmdId], syscmd[sysCmdId], syspms[sysCmdId], NULL );
	ManuTxt(-1, sysMsg[sysCmdId]);
	}
  return 0;
// } infoWidget("Fail to open libfsp.so", NULL, -1, NULL);
// return -1;
}
