/*
	Write by xempo 9 2014
	Free under LGPL
*/

#include <qpainter.h>
#include "statuspanel.h"
#include "simpleimage.h"
#include "stocks.h"
#include "conspace.h" // fsplus

StatusPanel::StatusPanel(QWidget *w, const int id) :
	QWidget(w), tag(id), fntSz(baseHeight),
	tmId(0), msgTxt(NULL),
	tmId2(0), msgTxt2(NULL),
	resTip(false), resTip2(false)
{
// popMenu=new ActMenu(topWdg);
fntBPos=(height()*2+fntSz) / 4; // - baseHeight/4 "base line"
}

static const char popAct[]=SLOT(popAct(int)),	closeAll[]=SLOT(closeAll()),
	menuOpen[]=SLOT(menuOpen(int)),	clearBrow[]=SLOT(clearBrwlst());

const char slot_openfsp[]=SLOT(openFsp(int)), slot_clearfsp[]=SLOT(clearFsp()),
	slot_openpath[]=SLOT(PZpath());

class StyleMenuItem : public QCustomMenuItem
{
public:
    StyleMenuItem( const QString& s, const QFont& f )
	: string( s ), font(f){};
    ~StyleMenuItem(){}
protected :
    void paint( QPainter* p, const QColorGroup& /*cg*/, bool /*act*/, bool /*enabled*/, int x, int y, int w, int h )
    {
	font.setItalic(true);
	p->setFont ( font );
	p->setPen( 0x838398 );
	p->drawText( x, y, w, h, AlignLeft | AlignVCenter | DontClip | ShowPrefix, string );
    }

    QSize sizeHint(){ return QFontMetrics( font ).size( AlignLeft | AlignVCenter | ShowPrefix | DontClip,  string ); }
private:
    QString string;
    QFont font;
};

void StatusPanel::showMsg(const char *txt, int tm, int left, int Color)
{// lefe 1bit: left, 2bit: no repaint()
if( (left&1) || tm<0){
	if(resTip)return;
	countTm=0;
	if(msgTxt){
		if(txt&&strcmp(msgTxt, txt)==0)return;
		free((void *)msgTxt);
	}
	msgTxt=txt ? strdup(txt) : NULL;
	if(tmId){ killTimer(tmId); tmId=0; }
	showTm=tm;	color=Color;
	if(showTm>0){
		tmId=startTimer(100);
	}
}
if( (left&1)==0||tm<0){
	if(resTip2)return;
	countTm2=0;
	if(msgTxt2){
		if(txt&&strcmp(msgTxt2, txt)==0)return;
		free((void *)msgTxt2);
	}
	msgTxt2=txt ? strdup(txt) : NULL;
	if(tmId2){ killTimer(tmId2); tmId2=0; }
	showTm2=tm;	color2=Color;
	if(showTm2>0){
		tmId2=startTimer(100);
	}

}
if((left&2)==0)repaint();

if(left&4){
	if(left&1)resTip=true;
	else resTip2=true;
}

}

bool StatusPanel::event(QEvent *e)
{
bool brw;
int s, f, i, n;
const char *txt;
switch(e->type()){
case QEvent::Paint : {
	QPainter pn(this);
	pn.eraseRect( geometry() );
	if(msgTxt){
		pn.setPen(color);
		pn.drawText(fntSz/3, fntBPos, QString::fromUtf8(msgTxt) );
	}
	if(msgTxt2){
	  QFontMetrics fmtr(topLevelWidget()->font());
	  QString S(QString::fromUtf8(msgTxt2));
	  pn.setPen(color2);
	  n=width()-fmtr.size(Qt::SingleLine, S).width()-fntSz/3;
	  if(n<0)n=0;
	  pn.drawText(n, fntBPos, S );
	}
	}
	return true;
case QEvent::Timer :
	if(tmId && ++countTm>showTm){
		resTip=false;
		killTimer(tmId);
		tmId=0;	showTm=0;
		if(msgTxt){
			QPainter pn(this);
			QFontMetrics fmtr(topLevelWidget()->font());
			pn.eraseRect( QRect(0,0, fmtr.size(Qt::SingleLine, QString::fromUtf8(msgTxt)).width()+fntSz/3, height()) );
			free((void *)msgTxt);
			msgTxt=NULL;
		}
	}
	if(tmId2 && ++countTm2>showTm2){
		resTip2=false;
		killTimer(tmId2);
		tmId2=0;	showTm2=0;
		if(msgTxt2){
			QPainter pn(this);
			QFontMetrics fmtr(topLevelWidget()->font());
			int len=fmtr.size(Qt::SingleLine, QString::fromUtf8(msgTxt2)).width()+fntSz/3;
			pn.eraseRect( QRect(width()-len, 0, len, height()) );
			free((void *)msgTxt2);
			msgTxt2=NULL;
		}
	}
	return true;
case QEvent::MouseButtonPress :
    brw=tag==0 &&  ((QMouseEvent *)e)->state()&Qt::ShiftButton ;
    switch( ((QMouseEvent *)e)->button()){
    case Qt::RightButton : {
	QWidget *topWidget=topLevelWidget();
	ActMenu popMenu(topWidget);
	popMenu.setFont(topWidget->font());
	switch(tag){
	case sbar_Fsplus : popMenu.lstCreatMenu(topWidget->parentWidget(), slot_openfsp, slot_clearfsp, fspSpaceImg, &menuPlus);
		goto _cmdlist_;
	case sbar_Grap :  popMenu.lstCreatMenu(topWidget, menuOpen, clearBrow, simpleImageImg, &menuSImage);
		goto _cmdlist_;
	case sbar_Brows : popMenu.lstCreatMenu(topWidget, menuOpen, clearBrow, recentUsedImg, &menubrows);
		goto _cmdlist_;
	case sbar_SearchModify :
	case sbar_MainWdg :
	case sbar_ProEdit : popMenu.lstCreatMenu(topWidget, brw ? SLOT(menuBrows(int)) :  menuOpen,
			brw ? clearBrow : SLOT(clearPElst()),
			recentUsedImg, brw ? &menubrows : &menulst);
		if(tag){ // pe
		_cmdlist_:
		    popMenu.insertMenu(pluzoneImg, popPluzone, topWidget, SLOT(popPluzone()), Key_F12);
		    if( (tag==sbar_Brows&&((HelpWdg *)topWidget)->getFileNam() )||tag==sbar_ProEdit){
			popMenu.insertMenu(dirOpenImg, openPath, topWidget, slot_openpath, Key_F11 );
			popMenu.insertMenu( copyImg, clipPath, topWidget, SLOT(clippath()), Key_F8 );
		    }
		    if(tag!=sbar_SearchModify&&tag!=sbar_Grap){
			QTextBrowser *brw;
			f=popMenu.insertMenu( linkOpenImg, fastLinkOpen, topWidget, SLOT(lnkopen()) , Key_F6 );
			s=popMenu.insertMenu( selectImg, selAsChs, topWidget, SLOT(selAs()), ALT+Key_S);
			switch(tag){
			case sbar_Fsplus : brw=((FspCon *)topWidget)->getBrowser();
					goto _set_;
			case sbar_Brows : brw=((HelpWdg *)topWidget)->getBrowser();
				_set_:	if(brw->selectedText().length()<1){
						popMenu.setItemEnabled(f, false);
						popMenu.setItemEnabled(s, false);
					}
				break;	
			case sbar_ProEdit :
				popMenu.insertMenu( develHelpImg, develHelpChs, topWidget, SLOT(develHelp()), Key_F8 );
				
			}
			popMenu.insertSeparator();
			}
		}
	}
	popMenu.insertMenu( quitImg, exitAll, tag? topWidget : (QObject *)qApp, tag ? SLOT(quitPrg()) : slot_quitPrg, Qt::CTRL+Qt::Key_Q );
	popMenu.exec(cursor().pos());
	}
	break;
    case Qt::LeftButton : if(tag)showMsg(tryDbClk, 40);
	}
	return true;
case QEvent::MouseButtonDblClick : {
	QObject *obj;
	QWidget *topWidget=topLevelWidget();
	ActMenu popMenu(topWidget);
	popMenu.setFont(topWidget->font());
	switch(tag){
	case sbar_Fsplus : {
		fsp_lib **pwks=workspace;
		s=0;
		for(i=0; i<SPACELIMIT; i++)if(pwks[i]){
			s=1;
			n=popMenu.insertItem(*pixmapLoad(pwks[i]->openMode&OpenAlway ? fspRTLImg : fspSpaceImg),
			tranText(strCodec, pwks[i]->fname), topWidget, popAct);
			popMenu.setItemParameter( n, i );
		}
		txt=closAllfsp;  // closeAllFsp;
		if(s)goto _pexe_;
		}
		break;
	case sbar_Brows : if(helpList.count()>1){
	_brows_:	HelpWdg *brows;
		for(i=0; (brows=helpList.at(i)); i++)if( brows!=topWidget ){
		    n=popMenu.insertItem(*pixmapLoad(htmlImg),brows->caption(),
// brows->getFileNam() ? tranText(strCodec, brows->getFileNam()) : brows->caption(),
			brows , popAct ); // tag ? topWidget :
		    popMenu.setItemParameter( n, i );
		}
		txt=closeAllBrows;
		goto _pexe_;
		}
		break;
	case sbar_ProEdit : if(proEditList.count()>1){
	_proedit_: ProEdit *pe;
		char buf[2048];
		for(i=0; (pe=proEditList.at(i)); i++)if(pe!=(ProEdit *)topWidget){
			const char *pt=pe->getFileName();
			if(pe->getModified()){
				scopy(buf+2, pt);
				*buf='*';	buf[1]=32;
				pt=buf;
			}
		    if(pe->isMinimized()){
			n=popMenu.insertItem(*pe->docIcon, new StyleMenuItem(tranText(strCodec,pt), topWidget->font()) ); // QCustMenuItem()
			popMenu.connectItem( n, pe, popAct);
		    }
		    else n=popMenu.insertItem(*pe->docIcon, tranText(strCodec,pt), pe , popAct );
		    popMenu.setItemParameter( n, i );
		}
		txt=closeAllPE;
	_pexe_:	showMsg("");
		popMenu.insertSeparator();
		if(tag!=sbar_MainWdg&&tag!=sbar_Fsplus){
			popMenu.insertMenu( recentImg, recentFileChs, topWidget,  SLOT(recent()), Qt::Key_F5);
			popMenu.insertSeparator();
		}
		popMenu.insertItem(*pixmapLoad(closeAllPEImg), QString::fromUtf8(txt),
			tag==sbar_SearchModify || tag==sbar_MainWdg ? obj : topWidget, closeAll );
		popMenu.exec(cursor().pos());
		return true;
	    	}
		break;
	case sbar_Grap :if(grapList.count()>1){
		SimpleImage *grap1;
		for(i=0; (grap1=grapList.at(i)); i++)if( grap1!=topWidget ){
		    if(grap1->isMinimized()){
			n=popMenu.insertItem(QPixmap(*grap1->getImage()), new StyleMenuItem(grap1->caption(), topWidget->font()) );
			popMenu.connectItem(n, grap1, popAct );
			}
		    else n=popMenu.insertItem(QPixmap(*grap1->getImage()), grap1->caption(), grap1, popAct ); // tag ? topWidget :
		    popMenu.setItemParameter( n, i );
		}
		txt=closeAllGrap;
		goto _pexe_;
		}
		break;
	case sbar_Stocks :if(stocksList.count()>1){
		FinaStocks *stocks1;
		for(i=0; (stocks1=stocksList.at(i)); i++)if( stocks1!=topWidget ){
		    n=popMenu.insertItem(*pixmapLoad(stocksImg), stocks1->caption(),
			stocks1 , popAct ); // tag ? topWidget :
		    popMenu.setItemParameter( n, i );
		}
		txt=closeAllStocks;
		goto _pexe_;
		}
		break;
	case sbar_SearchModify :
	case sbar_MainWdg :
		if(((QMouseEvent *)e)->state()&Qt::ShiftButton){
			if(helpList.count()>0){
				obj=(QObject *)helpList.at(0);
				goto _brows_;
				}
			}
		else {
			if(proEditList.count()>0){
				obj=(QObject *)proEditList.at(0);
				goto _proedit_;
				}
			}
	}
	showMsg(NotherAct, 30);
	return true;
	}
}
return QWidget::event(e);
}
